/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern5 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern5 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern5 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_HImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern7 (x3, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V4QImode:
      if (pattern8 (x3, 
E_V4QImode) != 0)
        return -1;
      return 7;

    case E_V2QImode:
      if (pattern8 (x3, 
E_V2QImode) != 0)
        return -1;
      return 8;

    case E_V2HImode:
      if (pattern8 (x3, 
E_V2HImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 0;

        case E_SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 1;

        case E_DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (!const_scalar_int_operand (operands[2], E_TImode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern7 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern7 (x1, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 3;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 4;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern76 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      res = pattern73 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern101 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V16HFmode:
          return 1;

        case E_V32HFmode:
          return 2;

        case E_V16SFmode:
          return 3;

        case E_V8SFmode:
          return 4;

        case E_V4SFmode:
          return 5;

        case E_V8DFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x5) != E_V2SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 2)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_V4SImode)
          || !nonimm_or_0_operand (operands[2], E_V2DFmode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern141 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode); /* [-1, 0] */

        case E_V32HImode:
          if (pattern141 (x1, 
E_V32HImode, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_V8HImode:
          if (pattern142 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x1) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode
              || !nonimm_or_0_operand (operands[2], E_V16SImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              return 3;

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x1) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode
              || !nonimm_or_0_operand (operands[2], E_V8SImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 5;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode
              || !nonimm_or_0_operand (operands[2], E_V4SImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 7;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x1) != E_V8DImode
              || GET_MODE (x4) != E_V8DImode
              || !nonimm_or_0_operand (operands[2], E_V8DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 9;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 10;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x1) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || !nonimm_or_0_operand (operands[2], E_V4DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 12;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 13;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2QImode:
              if (!memory_operand (operands[1], E_V2QImode))
                return -1;
              return 15;

            case E_V2HImode:
              if (!memory_operand (operands[1], E_V2HImode))
                return -1;
              return 16;

            case E_V2SImode:
              if (!memory_operand (operands[1], E_V2SImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern189 (x3); /* [-1, 1] */
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return pattern193 (x4); /* [-1, 7] */

    case ASHIFT:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 110)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern203 (x5, 
E_V2SFmode); /* [-1, 0] */
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_1_to_31_operand (operands[2], E_QImode))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  return 0;
}

int
pattern234 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      return pattern233 (x1); /* [-1, 1] */

    default:
      return -1;
    }
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 3)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      switch (XINT (x2, 1))
        {
        case 59:
          return 0;

        case 157:
          x7 = XVECEXP (x2, 0, 2);
          operands[5] = x7;
          if (!const_0_to_7_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern275 (x1, 
E_V16QImode, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_V8HImode:
              if (pattern275 (x1, 
E_V8HImode, 
E_QImode) != 0)
                return -1;
              return 2;

            case E_V4SImode:
              if (pattern275 (x1, 
E_V4SImode, 
E_QImode) != 0)
                return -1;
              return 3;

            case E_V2DImode:
              if (pattern275 (x1, 
E_V2DImode, 
E_QImode) != 0)
                return -1;
              return 4;

            case E_V32QImode:
              if (pattern275 (x1, 
E_V32QImode, 
E_SImode) != 0)
                return -1;
              return 5;

            case E_V16HImode:
              if (pattern275 (x1, 
E_V16HImode, 
E_HImode) != 0)
                return -1;
              return 6;

            case E_V8SImode:
              if (pattern275 (x1, 
E_V8SImode, 
E_QImode) != 0)
                return -1;
              return 7;

            case E_V4DImode:
              if (pattern275 (x1, 
E_V4DImode, 
E_QImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 59)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x8, 0, 1);
      operands[4] = x10;
      x11 = XVECEXP (x8, 0, 2);
      operands[5] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x1) != E_V8SImode
              || !vector_all_ones_operand (operands[1], E_V8SImode)
              || !const0_operand (operands[2], E_V8SImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8SFmode:
              if (!register_operand (operands[3], E_V8SFmode)
                  || !nonimmediate_operand (operands[4], E_V8SFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 9;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[3], E_V8SImode)
                  || !nonimmediate_operand (operands[4], E_V8SImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !vector_all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[3], E_V4SFmode)
                  || !nonimmediate_operand (operands[4], E_V4SFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 11;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[3], E_V4SImode)
                  || !nonimmediate_operand (operands[4], E_V4SImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 12;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x1) != E_V4DImode
              || !vector_all_ones_operand (operands[1], E_V4DImode)
              || !const0_operand (operands[2], E_V4DImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4DFmode:
              if (!register_operand (operands[3], E_V4DFmode)
                  || !nonimmediate_operand (operands[4], E_V4DFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 13;

            case E_V4DImode:
              if (!nonimmediate_operand (operands[3], E_V4DImode)
                  || !nonimmediate_operand (operands[4], E_V4DImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || !vector_all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2DFmode:
              if (!register_operand (operands[3], E_V2DFmode)
                  || !nonimmediate_operand (operands[4], E_V2DFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 15;

            case E_V2DImode:
              if (!nonimmediate_operand (operands[3], E_V2DImode)
                  || !nonimmediate_operand (operands[4], E_V2DImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 16;

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern276 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern276 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_V32QImode:
          if (pattern276 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 19;

        case E_V16HImode:
          if (pattern276 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      return 21;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const_scalar_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!memory_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!memory_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern358 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7)
    return -1;
  return 0;
}

int
pattern364 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern363 (x2, 
E_TImode); /* [-1, 0] */
}

int
pattern370 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !immediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!const_0_to_63_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!const_0_to_255_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (!const_0_to_31_operand (x7, E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern406 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern405 (x1, 
E_SImode, 
E_V32QImode, 
E_V32HFmode, 
E_V64QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern405 (x1, 
E_HImode, 
E_V16QImode, 
E_V16HFmode, 
E_V32QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern414 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern421 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || pattern420 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern426 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern426 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern426 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern426 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern426 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern426 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern426 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern426 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern426 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        case E_V16SImode:
          if (pattern120 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern120 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern120 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern120 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern120 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern120 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V64QImode:
          if (pattern120 (x1, 
E_V64QImode, 
E_DImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern120 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern120 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V32HImode:
          if (pattern120 (x1, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern120 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_V8HImode:
          if (pattern120 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 20;

        case E_V32BFmode:
          if (pattern122 (x1, 
E_V32BFmode, 
E_SImode) != 0)
            return -1;
          return 21;

        case E_V16BFmode:
          if (pattern122 (x1, 
E_V16BFmode, 
E_HImode) != 0)
            return -1;
          return 22;

        case E_V8BFmode:
          if (pattern122 (x1, 
E_V8BFmode, 
E_QImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern124 (x1);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!nonimmediate_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern465 (x1); /* [-1, 11] */

    case IOR:
      res = pattern465 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    case XOR:
      res = pattern465 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern466 (x1, 
E_V64QImode) != 0)
            return -1;
          return 36;

        case E_V32QImode:
          if (pattern466 (x1, 
E_V32QImode) != 0)
            return -1;
          return 37;

        case E_V16QImode:
          if (pattern466 (x1, 
E_V16QImode) != 0)
            return -1;
          return 38;

        case E_V32HImode:
          if (pattern466 (x1, 
E_V32HImode) != 0)
            return -1;
          return 39;

        case E_V16HImode:
          if (pattern466 (x1, 
E_V16HImode) != 0)
            return -1;
          return 40;

        case E_V8HImode:
          if (pattern466 (x1, 
E_V8HImode) != 0)
            return -1;
          return 41;

        case E_V16SImode:
          if (pattern466 (x1, 
E_V16SImode) != 0)
            return -1;
          return 42;

        case E_V8SImode:
          if (pattern466 (x1, 
E_V8SImode) != 0)
            return -1;
          return 43;

        case E_V4SImode:
          if (pattern466 (x1, 
E_V4SImode) != 0)
            return -1;
          return 44;

        case E_V8DImode:
          if (pattern466 (x1, 
E_V8DImode) != 0)
            return -1;
          return 45;

        case E_V4DImode:
          if (pattern466 (x1, 
E_V4DImode) != 0)
            return -1;
          return 46;

        case E_V2DImode:
          if (pattern466 (x1, 
E_V2DImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern479 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern483 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return pattern488 (x1); /* [-1, 4] */
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], E_V64QImode)
      || !nonimmediate_operand (operands[2], E_V64QImode)
      || !register_operand (operands[4], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (XVECLEN (x4, 0) != 3)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3)
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 1);
  operands[2] = x8;
  x9 = XVECEXP (x4, 0, 2);
  operands[3] = x9;
  if (!const_0_to_7_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[4] = x10;
  x11 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x6, 0, 2);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  switch (XINT (x4, 1))
    {
    case 59:
      if (XINT (x6, 1) != 59)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern494 (x1, 
E_HImode); /* [-1, 20] */

        case E_SImode:
          res = pattern494 (x1, 
E_SImode);
          if (res >= 0)
            return res + 21; /* [21, 41] */
          return -1;

        case E_DImode:
          res = pattern494 (x1, 
E_DImode);
          if (res >= 0)
            return res + 42; /* [42, 62] */
          return -1;

        default:
          return -1;
        }

    case 157:
      if (XINT (x6, 1) != 157)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          res = pattern495 (x1, 
E_HImode);
          if (res >= 0)
            return res + 63; /* [63, 74] */
          return -1;

        case E_SImode:
          res = pattern495 (x1, 
E_SImode);
          if (res >= 0)
            return res + 75; /* [75, 86] */
          return -1;

        case E_DImode:
          res = pattern495 (x1, 
E_DImode);
          if (res >= 0)
            return res + 87; /* [87, 98] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER
      || !register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  switch (GET_MODE (operands[3]))
    {
    case E_SFmode:
      return pattern518 (
E_V4SFmode, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern518 (
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 21
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != CONST
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x12 = XVECEXP (x4, 0, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x13 = XVECEXP (x4, 0, 1);
  operands[2] = x13;
  if (!constant_call_address_operand (operands[2], E_VOIDmode))
    return -1;
  x14 = XVECEXP (x7, 0, 0);
  operands[3] = x14;
  if (!tls_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[4] = x15;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x16 = XEXP (x9, 0);
  operands[5] = x16;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 119
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 119
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode)
      || !const_scalar_int_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return 0;

        case E_V16HFmode:
          return 1;

        case E_V8HFmode:
          return 2;

        case E_V16SFmode:
          return 3;

        case E_V8SFmode:
          return 4;

        case E_V4SFmode:
          return 5;

        case E_V8DFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        case E_V32BFmode:
          return 9;

        case E_V16BFmode:
          return 10;

        case E_V8BFmode:
          return 11;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x2, 0) != 1LL)
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 12;

        case E_V4SFmode:
          return 13;

        case E_V2DFmode:
          return 14;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern582 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (XWINT (x3, 0) != 1LL)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern581 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern581 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern581 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern589 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern595 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !vector_all_ones_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern602 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != CONST_VECTOR
      || XVECLEN (x3, 0) != 2
      || GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x2) != i2)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return pattern29 (x1); /* [-1, 1] */
}

int
pattern620 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1
      || pattern619 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern624 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 174)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 38
      || pattern646 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern658 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  return 0;
}

int
pattern666 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = XEXP (x1, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x7) != SET)
    return -1;
  return 0;
}

int
pattern674 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern673 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern673 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern681 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode))
        return -1;
      return 3;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern701 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  switch (GET_MODE (x1))
    {
    case E_HFmode:
      return 0;

    case E_SFmode:
      return 1;

    case E_DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern709 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern717 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern725 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern733 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_int_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern742 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern748 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != SUBREG
          || maybe_ne (SUBREG_BYTE (x10), 0))
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != ZERO_EXTRACT)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x14, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x2, 0);
          operands[4] = x17;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          return pattern535 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern769 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern773 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern779 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_int_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern784 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern783 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern783 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern794 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern801 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern810 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  return 0;
}

int
pattern840 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern849 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern848 (x3, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_TImode:
      if (pattern848 (x3, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern856 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      if (XINT (x4, 1) != 19)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern855 (x3, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern855 (x3, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 7
          || GET_MODE (x7) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST
          || GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 6
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[3] = x5;
      if (!tls_modbase_operand (operands[3], E_VOIDmode))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[4] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x8, 0, 0);
      operands[1] = x11;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern881 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !const123_operand (operands[2], E_VOIDmode)
      || !nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern884 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_BFmode)
      || GET_MODE (x1) != E_BFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32BFmode:
      if (!nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      return 0;

    case E_V16BFmode:
      if (!nonimmediate_operand (operands[1], E_V16BFmode))
        return -1;
      return 1;

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[1], E_V8BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern887 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern249 (x5); /* [-1, 1] */
}

int
pattern890 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[2], E_V32HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern897 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4DImode
      || !nonimm_or_0_operand (operands[2], E_V4DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern912 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern921 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern929 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern938 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern947 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != AND
          || GET_MODE (x10) != E_QImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XEXP (x3, 0);
      if (!nonmemory_operand (x12, E_QImode))
        return -1;
      switch (XWINT (x4, 0))
        {
        case 63LL:
          if (XWINT (x9, 0) != 64LL
              || XWINT (x11, 0) != 63LL
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x2) != E_DImode)
            return -1;
          x13 = XEXP (x2, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          operands[3] = x12;
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x6) != E_TImode
              || GET_MODE (x7) != E_TImode)
            return -1;
          x14 = XEXP (x7, 0);
          operands[2] = x14;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (!rtx_equal_p (x15, operands[3]))
            return -1;
          return 0;

        case 31LL:
          if (XWINT (x9, 0) != 32LL
              || XWINT (x11, 0) != 31LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 2;

    default:
      return -1;
    }
}

int
pattern982 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern981 (x2); /* [-1, 11] */
}

int
pattern989 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern998 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1006 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1011 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1020 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      if (!const0_operand (operands[4], E_V32HFmode))
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 223
          || GET_MODE (x7) != E_SImode
          || !register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || GET_MODE (x2) != E_V32HFmode
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !register_operand (operands[2], E_V32HFmode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      if (!register_operand (operands[5], E_HImode))
        return -1;
      operands[6] = x5;
      return 0;

    case REG:
    case SUBREG:
      x7 = XEXP (x2, 2);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 223
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || GET_MODE (x3) != E_V32HFmode
              || !register_operand (operands[1], E_V32HFmode)
              || !register_operand (operands[2], E_V32HFmode)
              || !register_operand (operands[3], E_V32HFmode))
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[4] = x8;
          if (!register_operand (operands[4], E_HImode))
            return -1;
          operands[5] = x5;
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          return 1;

        case CONST_INT:
          if (XWINT (x7, 0) != 3LL
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V8HFmode
              || GET_MODE (x3) != E_V8HFmode
              || !register_operand (operands[1], E_V8HFmode)
              || !register_operand (operands[2], E_V8HFmode)
              || !register_operand (operands[3], E_V8HFmode))
            return -1;
          operands[4] = x5;
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1063 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1072 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_CCCmode
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  if (!memory_operand (operands[2], i1))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x3, 1);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern1082 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !const_0_to_31_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1088 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1093 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      switch (XWINT (x4, 0))
        {
        case 64LL:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[2]))
            return -1;
          return 0;

        case 32LL:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
      if (pattern1117 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1135 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != IF_THEN_ELSE)
    return -1;
  x8 = XEXP (x7, 0);
  if (!bt_comparison_operator (x8, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1154 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1160 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1178 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1177 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1186 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V16HFmode
      || !nonimm_or_0_operand (operands[2], E_V16HFmode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1203 (x2, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1203 (x2, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern323 (x4); /* [-1, 1] */
}

int
pattern1221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2QImode)
      || GET_MODE (x1) != E_V2QImode
      || !register_operand (operands[1], E_V2QImode)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  operands[5] = x4;
  x5 = XEXP (x2, 1);
  operands[6] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET
      || pattern1226 (x7, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x2, 0);
      return pattern1237 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x2, 0);
      if (pattern1237 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1256 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1255 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1268 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1278 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1288 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return 0;

    case E_SImode:
      return 1;

    case E_DImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1324 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XVECEXP (x2, 0, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern1329 (x1, 
E_V4SImode, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern1329 (x1, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern1329 (x1, 
E_V8SImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V4DImode:
      if (pattern1329 (x1, 
E_V4DImode, 
E_V32QImode) != 0)
        return -1;
      return 3;

    case E_V32QImode:
      if (pattern1330 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern1330 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern1349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode)
          || !scratch_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode)
          || !scratch_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1367 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1366 (x3, 
i1); /* [-1, 0] */
}

int
pattern1374 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || pattern1373 () != 0)
    return -1;
  return 0;
}

int
pattern1382 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 3;

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || GET_MODE (x1) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern1399 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1407 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1417 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1433 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1439 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1443 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1450 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 2);
  return pattern1443 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1458 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1467 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1466 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1466 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1486 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!nonimm_or_0_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  return 0;
}

int
pattern1497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1523 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i3))
    return -1;
  return 0;
}

int
pattern1534 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1543 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1547 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode)
          || !register_operand (operands[6], E_QImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1568 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1567 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1567 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1586 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1585 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1585 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !const_int_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1602 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_HImode
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1614 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      return pattern1612 (
E_HImode, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8DImode:
      if (pattern1612 (
E_QImode, 
E_V8SFmode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1628 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1636 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != COMPARE)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17)
    return -1;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  return 0;
}

int
pattern1658 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_V2QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 2)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 2)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x14 = XEXP (x2, 1);
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != i1)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != VEC_SELECT
      || GET_MODE (x16) != E_V2QImode)
    return -1;
  x17 = XEXP (x16, 1);
  if (GET_CODE (x17) != PARALLEL
      || XVECLEN (x17, 0) != 2)
    return -1;
  x18 = XVECEXP (x17, 0, 0);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x19 = XVECEXP (x17, 0, 1);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x20 = XEXP (x14, 1);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != VEC_SELECT
      || GET_MODE (x21) != E_V2QImode)
    return -1;
  x22 = XEXP (x21, 1);
  if (GET_CODE (x22) != PARALLEL
      || XVECLEN (x22, 0) != 2)
    return -1;
  x23 = XVECEXP (x22, 0, 0);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x24 = XVECEXP (x22, 0, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x25 = XEXP (x1, 1);
  x26 = XEXP (x25, 0);
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != i1)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != VEC_SELECT
      || GET_MODE (x28) != E_V2QImode)
    return -1;
  x29 = XEXP (x28, 1);
  if (GET_CODE (x29) != PARALLEL
      || XVECLEN (x29, 0) != 2)
    return -1;
  x30 = XVECEXP (x29, 0, 0);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x31 = XVECEXP (x29, 0, 1);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x32 = XEXP (x26, 1);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != VEC_SELECT
      || GET_MODE (x33) != E_V2QImode)
    return -1;
  x34 = XEXP (x33, 1);
  if (GET_CODE (x34) != PARALLEL
      || XVECLEN (x34, 0) != 2)
    return -1;
  x35 = XVECEXP (x34, 0, 0);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x36 = XVECEXP (x34, 0, 1);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x37 = XEXP (x25, 1);
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != VEC_SELECT
      || GET_MODE (x39) != E_V2QImode)
    return -1;
  x40 = XEXP (x39, 1);
  if (GET_CODE (x40) != PARALLEL
      || XVECLEN (x40, 0) != 2)
    return -1;
  x41 = XVECEXP (x40, 0, 0);
  if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x42 = XVECEXP (x40, 0, 1);
  if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x43 = XEXP (x37, 1);
  if (GET_CODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != VEC_SELECT
      || GET_MODE (x44) != E_V2QImode)
    return -1;
  x45 = XEXP (x44, 1);
  if (GET_CODE (x45) != PARALLEL
      || XVECLEN (x45, 0) != 2)
    return -1;
  x46 = XVECEXP (x45, 0, 0);
  if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x47 = XVECEXP (x45, 0, 1);
  if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  x48 = XEXP (x5, 0);
  operands[1] = x48;
  if (!nonimmediate_operand (operands[1], E_V16QImode))
    return -1;
  x49 = XEXP (x10, 0);
  if (!rtx_equal_p (x49, operands[1]))
    return -1;
  x50 = XEXP (x16, 0);
  if (!rtx_equal_p (x50, operands[1]))
    return -1;
  x51 = XEXP (x21, 0);
  if (!rtx_equal_p (x51, operands[1]))
    return -1;
  x52 = XEXP (x28, 0);
  if (!rtx_equal_p (x52, operands[1]))
    return -1;
  x53 = XEXP (x33, 0);
  if (!rtx_equal_p (x53, operands[1]))
    return -1;
  x54 = XEXP (x39, 0);
  if (!rtx_equal_p (x54, operands[1]))
    return -1;
  x55 = XEXP (x44, 0);
  if (!rtx_equal_p (x55, operands[1]))
    return -1;
  return 0;
}

int
pattern1713 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1721 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_int_operand (operands[6], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  return pattern1716 (x11, 
i1); /* [-1, 0] */
}

int
pattern1731 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 24);
  if (XWINT (x2, 0) != 28LL)
    return -1;
  x3 = XVECEXP (x1, 0, 25);
  if (XWINT (x3, 0) != 60LL)
    return -1;
  x4 = XVECEXP (x1, 0, 26);
  if (XWINT (x4, 0) != 29LL)
    return -1;
  x5 = XVECEXP (x1, 0, 27);
  if (XWINT (x5, 0) != 61LL)
    return -1;
  x6 = XVECEXP (x1, 0, 28);
  if (XWINT (x6, 0) != 30LL)
    return -1;
  x7 = XVECEXP (x1, 0, 29);
  if (XWINT (x7, 0) != 62LL)
    return -1;
  x8 = XVECEXP (x1, 0, 30);
  if (XWINT (x8, 0) != 31LL)
    return -1;
  x9 = XVECEXP (x1, 0, 31);
  if (XWINT (x9, 0) != 63LL)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x1, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCFPmode)
    return -1;
  x10 = XEXP (x3, 0);
  operands[0] = x10;
  x11 = XEXP (x6, 0);
  operands[1] = x11;
  switch (GET_MODE (x3))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x6) != E_HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !(
#line 4857 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3109; /* avx10_2_comxhf */

    case E_SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !
#line 4857 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 3113; /* avx10_2_comxsf */

    case E_DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !
#line 4857 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 3117; /* avx10_2_comxdf */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 105:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!push_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3889 "../../../gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2))
        return -1;
      return 133; /* push2_di */

    case 40:
      if (GET_MODE (x2) != E_CCCmode
          || pattern228 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case LTU:
          if (pattern648 (x4) != 0)
            return -1;
          x6 = XEXP (x4, 0);
          switch (GET_MODE (x6))
            {
            case E_CCmode:
              if (!
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 445; /* *setcc_qi_negqi_ccc_2_cc */

            case E_CCCmode:
              if (!
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 446; /* *setcc_qi_negqi_ccc_2_ccc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 796; /* *negqi_ccc_2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              *pnum_clobbers = 1;
              return 797; /* *neghi_ccc_2 */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 798; /* *negsi_ccc_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 66:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_XFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_XFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24147 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1381; /* atan2xf3 */

    case 67:
      if (pnum_clobbers == NULL
          || pattern71 (x1, 
E_XFmode) != 0
          || !
#line 24450 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1382; /* fyl2xxf3_i387 */

    case 68:
      if (pnum_clobbers == NULL
          || pattern71 (x1, 
E_XFmode) != 0
          || !
#line 24547 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1383; /* fyl2xp1xf3_i387 */

    case 58:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern64 (x2, 
E_SFmode) != 0
              || !
#line 24856 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F))
            return -1;
          return 1387; /* avx512f_scalefsf2 */

        case E_DFmode:
          if (pattern64 (x2, 
E_DFmode) != 0
              || !
#line 24856 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F))
            return -1;
          return 1388; /* avx512f_scalefdf2 */

        default:
          return -1;
        }

    case 94:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_15_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 24974 "../../../gcc/config/i386/i386.md"
(TARGET_SSE4_1) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
            return -1;
          return 1389; /* sse4_1_roundhf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 24974 "../../../gcc/config/i386/i386.md"
(TARGET_SSE4_1))
            return -1;
          return 1390; /* sse4_1_roundsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 24974 "../../../gcc/config/i386/i386.md"
(TARGET_SSE4_1))
            return -1;
          return 1391; /* sse4_1_rounddf2 */

        default:
          return -1;
        }

    case 63:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 26775 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1467; /* *ieee_smaxhf3 */

        case 1:
          if (!
#line 26787 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return -1;
          return 1469; /* *ieee_smaxsf3 */

        case 2:
          if (!
#line 26787 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return -1;
          return 1471; /* *ieee_smaxdf3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 26775 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1468; /* *ieee_sminhf3 */

        case 1:
          if (!
#line 26787 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return -1;
          return 1470; /* *ieee_sminsf3 */

        case 2:
          if (!
#line 26787 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return -1;
          return 1472; /* *ieee_smindf3 */

        default:
          return -1;
        }

    case 113:
      if (pattern66 (x1, 
E_V2SFmode) != 0
          || !
#line 911 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1634; /* mmx_rcpit1v2sf3 */

    case 114:
      if (pattern66 (x1, 
E_V2SFmode) != 0
          || !
#line 922 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1635; /* mmx_rcpit2v2sf3 */

    case 116:
      if (pattern66 (x1, 
E_V2SFmode) != 0
          || !
#line 959 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1637; /* mmx_rsqit1v2sf3 */

    case 57:
      if (pattern67 (x1, 
E_V4HImode) != 0
          || !
#line 4792 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 1815; /* mmx_packuswb */

    case 52:
      if (GET_MODE (x2) != E_V4QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vector_operand (operands[2], E_V16QImode)
          || !
#line 5507 "../../../gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 1835; /* mmx_pshufbv4qi3 */

    case 56:
      if (GET_MODE (x2) != E_V1DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_mmxmem_operand (operands[1], E_V8QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_mmxmem_operand (operands[2], E_V8QImode)
          || !
#line 6477 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (PLUS, V8QImode, operands)))
        return -1;
      return 1875; /* *mmx_psadbw */

    case 176:
      if (pattern68 (x1) != 0)
        return -1;
      switch (pattern874 ())
        {
        case 0:
          if (!(
#line 2338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2082 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2098; /* ktestqi */

        case 1:
          if (!(
#line 2338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2082 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2099; /* ktesthi */

        case 2:
          if (!(
#line 2338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2083 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2100; /* ktestsi */

        case 3:
          if (!(
#line 2338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2083 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2101; /* ktestdi */

        default:
          return -1;
        }

    case 178:
      return recog_7 (x1, insn, pnum_clobbers);

    case 61:
      return recog_8 (x1, insn, pnum_clobbers);

    case 158:
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7456; /* avx512vl_testmv16qi3 */

        case 1:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7460; /* avx512vl_testmv16hi3 */

        case 2:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7464; /* avx512f_testmv16si3 */

        case 3:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7462; /* avx512vl_testmv8hi3 */

        case 4:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7466; /* avx512vl_testmv8si3 */

        case 5:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7468; /* avx512vl_testmv4si3 */

        case 6:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7470; /* avx512f_testmv8di3 */

        case 7:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7472; /* avx512vl_testmv4di3 */

        case 8:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7474; /* avx512vl_testmv2di3 */

        default:
          return -1;
        }

    case 159:
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7480; /* avx512vl_testnmv16qi3 */

        case 1:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7484; /* avx512vl_testnmv16hi3 */

        case 2:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7488; /* avx512f_testnmv16si3 */

        case 3:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7486; /* avx512vl_testnmv8hi3 */

        case 4:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7490; /* avx512vl_testnmv8si3 */

        case 5:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7492; /* avx512vl_testnmv4si3 */

        case 6:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7494; /* avx512f_testnmv8di3 */

        case 7:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7496; /* avx512vl_testnmv4di3 */

        case 8:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7498; /* avx512vl_testnmv2di3 */

        default:
          return -1;
        }

    case 120:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern671 (x2, 
E_V8QImode) != 0
              || !
#line 23191 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 7931; /* ssse3_psignv8qi3 */

        case E_V4HImode:
          if (pattern671 (x2, 
E_V4HImode) != 0
              || !
#line 23191 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 7932; /* ssse3_psignv4hi3 */

        case E_V2SImode:
          if (pattern671 (x2, 
E_V2SImode) != 0
              || !
#line 23191 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 7933; /* ssse3_psignv2si3 */

        default:
          return -1;
        }

    case 148:
      if (pattern68 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || !nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 25291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8228; /* avx_vtestps256 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 25291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8229; /* avx_vtestps */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || !nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 25291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8230; /* avx_vtestpd256 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || !nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 25291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8231; /* avx_vtestpd */

        default:
          return -1;
        }

    case 130:
      return recog_9 (x1, insn, pnum_clobbers);

    case 150:
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_V4HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode)
          || !
#line 29146 "../../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return -1;
      return 8952; /* *vcvtps2ph_store */

    case 193:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern576 (x2, 
E_HImode))
            {
            case 0:
              if (!(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16HFmode)) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 9277; /* avx512dq_fpclassv16hf */

            case 1:
              if (!(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9281; /* avx512dq_fpclassv16sf */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 9279; /* avx512dq_fpclassv8hf */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9283; /* avx512dq_fpclassv8sf */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9285; /* avx512dq_fpclassv4sf */

            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9287; /* avx512dq_fpclassv8df */

            case E_V4DFmode:
              if (!vector_operand (operands[1], E_V4DFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9289; /* avx512dq_fpclassv4df */

            case E_V2DFmode:
              if (!vector_operand (operands[1], E_V2DFmode)
                  || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9291; /* avx512dq_fpclassv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 214:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!nonimmediate_operand (operands[2], E_V16QImode)
          || !(
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9611; /* avx512vl_vpshufbitqmbv16qi */

    case 215:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_P2QImode:
          if (!register_operand (operands[0], E_P2QImode)
              || GET_MODE (x2) != E_P2QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !vector_operand (operands[2], E_V8DImode)
                  || !(
#line 30967 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30933 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9617; /* avx512vp2intersect_2intersectv8di */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !vector_operand (operands[2], E_V4DImode)
                  || !(
#line 30967 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9618; /* avx512vp2intersect_2intersectv4di */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !vector_operand (operands[2], E_V2DImode)
                  || !(
#line 30967 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9619; /* avx512vp2intersect_2intersectv2di */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !vector_operand (operands[2], E_V8SImode)
                  || !(
#line 30967 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30935 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9620; /* avx512vp2intersect_2intersectv8si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !vector_operand (operands[2], E_V4SImode)
                  || !(
#line 30967 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30935 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9621; /* avx512vp2intersect_2intersectv4si */

            default:
              return -1;
            }

        case E_P2HImode:
          if (pattern672 (x2, 
E_V16SImode, 
E_P2HImode) != 0
              || !
#line 30976 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT && TARGET_EVEX512))
            return -1;
          return 9622; /* avx512vp2intersect_2intersectv16si */

        default:
          return -1;
        }

    case 262:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_V16BFmode)
              || !
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10005; /* avx10_2_fpclassbf16_v16bf */

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_V8BFmode)
              || !
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10007; /* avx10_2_fpclassbf16_v8bf */

        default:
          return -1;
        }

    case 288:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonmemory_operand (operands[1], E_QImode))
            return -1;
          return 10258; /* atomic_storeqi_1 */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonmemory_operand (operands[1], E_HImode))
            return -1;
          return 10259; /* atomic_storehi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern1147 (x1))
            {
            case 0:
              if (
#line 12770 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 593; /* *andqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12770 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 596; /* *andqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12770 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 599; /* *andqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 615; /* *andqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 618; /* *andqi_extsi_0 */

            default:
              break;
            }
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != SUBREG)
            return -1;
          switch (pattern1149 (x1))
            {
            case 0:
              if (!
#line 12803 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 602; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12803 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 605; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12803 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 608; /* *andqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 621; /* *andqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 624; /* *andqi_ext2si_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x9 = XEXP (x1, 0);
          operands[0] = x9;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1231 (x2, 
E_QImode) != 0
                  || !
#line 18962 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1160; /* *btrqi_1 */

            case E_HImode:
              if (pattern1231 (x2, 
E_HImode) != 0
                  || !
#line 18962 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1161; /* *btrhi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pnum_clobbers != NULL
              && pattern679 (x2, 
E_TImode) == 0
              && (
#line 13332 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 656; /* *andnti3_doubleword */
            }
          break;

        case E_QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_QImode) == 0
              && 
#line 13364 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 658; /* *andnqi_1 */
            }
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_HImode) == 0
              && 
#line 13364 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 659; /* *andnhi_1 */
            }
          break;

        case E_V2BFmode:
          if (pattern553 (x2, 
E_V2BFmode) == 0
              && 
#line 2568 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1659; /* *mmx_andnotv2bf3 */
          break;

        case E_V2HFmode:
          if (pattern553 (x2, 
E_V2HFmode) == 0
              && 
#line 2568 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1660; /* *mmx_andnotv2hf3 */
          break;

        case E_V8QImode:
          if (pattern554 (x2, 
E_V8QImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1790; /* mmx_andnotv8qi3 */
          break;

        case E_V4HImode:
          if (pattern554 (x2, 
E_V4HImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1791; /* mmx_andnotv4hi3 */
          break;

        case E_V2SImode:
          if (pattern554 (x2, 
E_V2SImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1792; /* mmx_andnotv2si3 */
          break;

        case E_V4QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V4QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1793; /* *andnotv4qi3 */
            }
          break;

        case E_V2QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V2QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1794; /* *andnotv2qi3 */
            }
          break;

        case E_V2HImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V2HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1795; /* *andnotv2hi3 */
            }
          break;

        case E_BFmode:
          if (pattern553 (x2, 
E_BFmode) == 0
              && 
#line 5535 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3218; /* *andnotbf3 */
          break;

        case E_HFmode:
          if (pattern553 (x2, 
E_HFmode) == 0
              && 
#line 5535 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3219; /* *andnothf3 */
          break;

        case E_SFmode:
          if (pattern553 (x2, 
E_SFmode) == 0
              && 
#line 5535 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3220; /* *andnotsf3 */
          break;

        case E_DFmode:
          if (pattern553 (x2, 
E_DFmode) == 0
              && (
#line 5535 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3221; /* *andnotdf3 */
          break;

        case E_TFmode:
          if (pattern555 (x2, 
E_TFmode) == 0
              && 
#line 5605 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3222; /* *andnottf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_QImode)
          || GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19364 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1183; /* *btsi_setncqi */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19364 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1184; /* *btdi_setncqi */

        default:
          return -1;
        }

    case UNSPEC:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      switch (XVECLEN (x3, 0))
        {
        case 3:
          x12 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 59:
              operands[3] = x12;
              res = recog_32 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              if (XWINT (x12, 0) != 0LL)
                return -1;
              switch (pattern878 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2940; /* *avx512vl_eqv16qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2952; /* *avx512vl_eqv16hi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3008; /* *avx512f_eqv16si3_mask_1 */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2956; /* *avx512vl_eqv8hi3_mask_1 */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3012; /* *avx512vl_eqv8si3_mask_1 */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3016; /* *avx512vl_eqv4si3_mask_1 */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3020; /* *avx512f_eqv8di3_mask_1 */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3024; /* *avx512vl_eqv4di3_mask_1 */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3028; /* *avx512vl_eqv2di3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x12, 0) == 0LL)
                {
                  switch (pattern878 (x2))
                    {
                    case 0:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2942; /* *avx512vl_eqv16qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2954; /* *avx512vl_eqv16hi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3010; /* *avx512f_eqv16si3_mask_1 */
                      break;

                    case 3:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2958; /* *avx512vl_eqv8hi3_mask_1 */
                      break;

                    case 4:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3014; /* *avx512vl_eqv8si3_mask_1 */
                      break;

                    case 5:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3018; /* *avx512vl_eqv4si3_mask_1 */
                      break;

                    case 6:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3022; /* *avx512f_eqv8di3_mask_1 */
                      break;

                    case 7:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3026; /* *avx512vl_eqv4di3_mask_1 */
                      break;

                    case 8:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3030; /* *avx512vl_eqv2di3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x12;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern969 (x2))
                {
                case 0:
                  switch (pattern680 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2962; /* avx512vl_ucmpv16qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2968; /* avx512vl_ucmpv16hi3_mask */

                    case 2:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3032; /* avx512f_ucmpv16si3_mask */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern681 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2970; /* avx512vl_ucmpv8hi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3034; /* avx512vl_ucmpv8si3_mask */

                    case 2:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3036; /* avx512vl_ucmpv4si3_mask */

                    case 3:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3038; /* avx512f_ucmpv8di3_mask */

                    case 4:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3040; /* avx512vl_ucmpv4di3_mask */

                    case 5:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3042; /* avx512vl_ucmpv2di3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 158:
              switch (pattern682 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7457; /* avx512vl_testmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7461; /* avx512vl_testmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7465; /* avx512f_testmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7463; /* avx512vl_testmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7467; /* avx512vl_testmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7469; /* avx512vl_testmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7471; /* avx512f_testmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7473; /* avx512vl_testmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7475; /* avx512vl_testmv2di3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern682 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7481; /* avx512vl_testnmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7485; /* avx512vl_testnmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7489; /* avx512f_testnmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7487; /* avx512vl_testnmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7491; /* avx512vl_testnmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7493; /* avx512vl_testnmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7495; /* avx512f_testnmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7497; /* avx512vl_testnmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7499; /* avx512vl_testnmv2di3_mask */

                default:
                  return -1;
                }

            case 193:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[3] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern251 (x2, 
E_HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V16HFmode:
                          if (!vector_operand (operands[1], E_V16HFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16HFmode)) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9278; /* avx512dq_fpclassv16hf_mask */

                        case E_V16SFmode:
                          if (!vector_operand (operands[1], E_V16SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9282; /* avx512dq_fpclassv16sf_mask */

                        default:
                          return -1;
                        }

                    case E_QImode:
                      if (pattern251 (x2, 
E_QImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V8HFmode:
                          if (!vector_operand (operands[1], E_V8HFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9280; /* avx512dq_fpclassv8hf_mask */

                        case E_V8SFmode:
                          if (!vector_operand (operands[1], E_V8SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9284; /* avx512dq_fpclassv8sf_mask */

                        case E_V4SFmode:
                          if (!vector_operand (operands[1], E_V4SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9286; /* avx512dq_fpclassv4sf_mask */

                        case E_V8DFmode:
                          if (!vector_operand (operands[1], E_V8DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9288; /* avx512dq_fpclassv8df_mask */

                        case E_V4DFmode:
                          if (!vector_operand (operands[1], E_V4DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9290; /* avx512dq_fpclassv4df_mask */

                        case E_V2DFmode:
                          if (!vector_operand (operands[1], E_V2DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9292; /* avx512dq_fpclassv2df_mask */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x8, 0) != 1LL
                      || !register_operand (operands[0], E_QImode)
                      || GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V8HFmode:
                      if (!nonimmediate_operand (operands[1], E_V8HFmode)
                          || !(
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 9293; /* avx512dq_vmfpclassv8hf */

                    case E_V4SFmode:
                      if (!nonimmediate_operand (operands[1], E_V4SFmode)
                          || !
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)))
                        return -1;
                      return 9295; /* avx512dq_vmfpclassv4sf */

                    case E_V2DFmode:
                      if (!nonimmediate_operand (operands[1], E_V2DFmode)
                          || !(
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 9297; /* avx512dq_vmfpclassv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 214:
              if (GET_MODE (x3) != E_HImode
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !nonimmediate_operand (operands[2], E_V16QImode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              if (!register_operand (operands[3], E_HImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9612; /* avx512vl_vpshufbitqmbv16qi_mask */

            case 262:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern970 (x2, 
E_HImode, 
E_V16BFmode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10006; /* avx10_2_fpclassbf16_v16bf_mask */

                case E_QImode:
                  if (pattern970 (x2, 
E_QImode, 
E_V8BFmode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10008; /* avx10_2_fpclassbf16_v8bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (pattern85 (x4, 
E_QImode, 
193) != 0)
        return -1;
      x15 = XEXP (x3, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x16 = XVECEXP (x4, 0, 0);
      operands[1] = x16;
      x17 = XVECEXP (x4, 0, 1);
      operands[2] = x17;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 9294; /* avx512dq_vmfpclassv8hf_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode))))
            return -1;
          return 9296; /* avx512dq_vmfpclassv4sf_mask */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 9298; /* avx512dq_vmfpclassv2df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = recog_72 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CLZ
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21296 "../../../gcc/config/i386/i386.md"
(!TARGET_LZCNT))
        return -1;
      *pnum_clobbers = 1;
      return 1256; /* bsr_1 */

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern256 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1157 (x3, 
E_SImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* subsi3_carry */

            case E_DImode:
              if (pattern1157 (x3, 
E_DImode) != 0
                  || !(
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* subdi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1090 (x3, 
E_SImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 481; /* *subsi3_eq */

            case E_DImode:
              if (pattern1090 (x3, 
E_DImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 482; /* *subdi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers != NULL)
        {
          res = recog_75 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonimmediate_operand (operands[3], E_SImode)
          || !
#line 26339 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 1453; /* *movsicc_noc */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern74 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 12503 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *anddi3_doubleword */

        case E_SImode:
          if (pattern378 (x3) != 0)
            return -1;
          if (
#line 12673 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 583; /* *andsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 12673 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 584; /* *andsi_1 */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern679 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 13314 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 654; /* *andndi3_doubleword_bmi */
                }
              if (!(
#line 13332 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 655; /* *andndi3_doubleword */

            case E_SImode:
              if (pattern679 (x3, 
E_SImode) != 0
                  || !
#line 13348 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
                return -1;
              *pnum_clobbers = 1;
              return 657; /* *andnsi_1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern984 (x3, 
E_SImode) != 0
                  || !
#line 19382 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1185; /* *btsi_setncsi */

            case E_DImode:
              if (pattern984 (x3, 
E_DImode) != 0
                  || !(
#line 19382 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1186; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22104 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1293; /* *bmi2_bzhi_si3_3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      switch (pattern253 (x3))
        {
        case 0:
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (pattern695 (x3) == 0
              && 
#line 18893 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
            {
              *pnum_clobbers = 1;
              return 1155; /* *btrsi */
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern696 (x3))
            {
            case 0:
              if (!
#line 18912 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1156; /* *btrsi_mask */

            case 1:
              if (!(
#line 18912 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18940 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1158; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18940 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1159; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern386 (x3) != 0
          || !
#line 21781 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      *pnum_clobbers = 1;
      return 1277; /* *bmi_blsi_si */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != CONST_INT
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x9, 0))
            {
            case -1LL:
              x5 = XEXP (x3, 1);
              switch (pattern1087 (x5))
                {
                case 0:
                  if (!
#line 21926 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1286; /* *bmi_blsr_si */

                case 1:
                  if (!
#line 22297 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1305; /* *tbm_tzmsk_si */

                default:
                  return -1;
                }

            case 1LL:
              x5 = XEXP (x3, 1);
              switch (pattern1087 (x5))
                {
                case 0:
                  if (!
#line 22188 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1297; /* *tbm_blcfill_si */

                case 1:
                  if (!
#line 22216 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1299; /* *tbm_blcic_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x9, 0) != -1LL)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22090 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1292; /* *bmi2_bzhi_si3_2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x10 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          switch (XINT (x4, 1))
            {
            case 59:
              operands[3] = x10;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern968 (x3, 
E_SImode) == 0)
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V32HFmode:
                          if (register_operand (operands[1], E_V32HFmode)
                              && nonimmediate_operand (operands[2], E_V32HFmode)
                              && const_0_to_31_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                            return 2748; /* avx512bw_cmpv32hf3_mask */
                          break;

                        case E_V32QImode:
                          if (register_operand (operands[1], E_V32QImode)
                              && nonimmediate_operand (operands[2], E_V32QImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return 2880; /* avx512vl_cmpv32qi3_mask */
                          break;

                        case E_V32HImode:
                          if (register_operand (operands[1], E_V32HImode)
                              && nonimmediate_operand (operands[2], E_V32HImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return 2882; /* avx512bw_cmpv32hi3_mask */
                          break;

                        case E_V32BFmode:
                          if (register_operand (operands[1], E_V32BFmode)
                              && nonimmediate_operand (operands[2], E_V32BFmode)
                              && const_0_to_31_operand (operands[3], E_VOIDmode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32454 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                            return 10010; /* avx10_2_cmpbf16_v32bf_mask */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case E_DImode:
                  if (pattern891 (x3) == 0
                      && register_operand (operands[4], E_DImode)
                      && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 2876; /* avx512bw_cmpv64qi3_mask */
                  break;

                default:
                  break;
                }
              if (XWINT (x10, 0) != 0LL)
                return -1;
              switch (pattern889 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2936; /* *avx512bw_eqv64qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2944; /* *avx512vl_eqv32qi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2948; /* *avx512bw_eqv32hi3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x10, 0) == 0LL)
                {
                  switch (pattern889 (x3))
                    {
                    case 0:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2938; /* *avx512bw_eqv64qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2946; /* *avx512vl_eqv32qi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2950; /* *avx512bw_eqv32hi3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x10;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern985 (x3, 
E_V64QImode, 
E_DImode) != 0
                      || !register_operand (operands[4], E_DImode)
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2960; /* avx512bw_ucmpv64qi3_mask */

                case E_SImode:
                  if (pattern968 (x3, 
E_SImode) != 0)
                    return -1;
                  switch (pattern792 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2964; /* avx512vl_ucmpv32qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 2966; /* avx512bw_ucmpv32hi3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (XINT (x4, 1))
            {
            case 158:
              switch (pattern795 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7453; /* avx512bw_testmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7455; /* avx512vl_testmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7459; /* avx512bw_testmv32hi3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern795 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7477; /* avx512bw_testnmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7479; /* avx512vl_testnmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7483; /* avx512bw_testnmv32hi3_mask */

                default:
                  return -1;
                }

            case 193:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 9276; /* avx512dq_fpclassv32hf_mask */

            case 214:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern794 (x3, 
E_DImode, 
E_V64QImode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9610; /* avx512vl_vpshufbitqmbv64qi_mask */

                case E_SImode:
                  if (pattern794 (x3, 
E_SImode, 
E_V32QImode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9614; /* avx512vl_vpshufbitqmbv32qi_mask */

                default:
                  return -1;
                }

            case 262:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_V32BFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10004; /* avx10_2_fpclassbf16_v32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern893 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 514 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10230; /* avx10_2_vmovrsbv64qi_mask */

    case E_V32QImode:
      if (pattern893 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10232; /* avx10_2_vmovrsbv32qi_mask */

    case E_V16QImode:
      if (pattern893 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10234; /* avx10_2_vmovrsbv16qi_mask */

    case E_V32HImode:
      if (pattern893 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 515 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10236; /* avx10_2_vmovrswv32hi_mask */

    case E_V16HImode:
      if (pattern893 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10238; /* avx10_2_vmovrswv16hi_mask */

    case E_V8HImode:
      if (pattern893 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10240; /* avx10_2_vmovrswv8hi_mask */

    case E_V16SImode:
      if (pattern893 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 516 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10242; /* avx10_2_vmovrsdv16si_mask */

    case E_V8SImode:
      if (pattern893 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10244; /* avx10_2_vmovrsdv8si_mask */

    case E_V4SImode:
      if (pattern893 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10246; /* avx10_2_vmovrsdv4si_mask */

    case E_V8DImode:
      if (pattern893 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10248; /* avx10_2_vmovrsqv8di_mask */

    case E_V4DImode:
      if (pattern893 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10250; /* avx10_2_vmovrsqv4di_mask */

    case E_V2DImode:
      if (pattern893 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10252; /* avx10_2_vmovrsqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern902 (x2, 
E_V16SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8657; /* *avx512f_vpermi2varv16si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8723; /* avx512f_vpermt2varv16si3_mask */
            }
          break;

        case E_V8DImode:
          if (pattern902 (x2, 
E_V8DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8658; /* *avx512f_vpermi2varv8di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8725; /* avx512f_vpermt2varv8di3_mask */
            }
          break;

        case E_V8SImode:
          if (pattern902 (x2, 
E_V8SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8659; /* *avx512vl_vpermi2varv8si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8727; /* avx512vl_vpermt2varv8si3_mask */
            }
          break;

        case E_V4SImode:
          if (pattern902 (x2, 
E_V4SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8660; /* *avx512vl_vpermi2varv4si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8731; /* avx512vl_vpermt2varv4si3_mask */
            }
          break;

        case E_V4DImode:
          if (pattern902 (x2, 
E_V4DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8661; /* *avx512vl_vpermi2varv4di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8729; /* avx512vl_vpermt2varv4di3_mask */
            }
          break;

        case E_V2DImode:
          if (pattern902 (x2, 
E_V2DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8662; /* *avx512vl_vpermi2varv2di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8733; /* avx512vl_vpermt2varv2di3_mask */
            }
          break;

        case E_V32HImode:
          if (pattern902 (x2, 
E_V32HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8663; /* *avx512bw_vpermi2varv32hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8735; /* avx512bw_vpermt2varv32hi3_mask */
            }
          break;

        case E_V16HImode:
          if (pattern902 (x2, 
E_V16HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28139 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8664; /* *avx512vl_vpermi2varv16hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8736; /* avx512vl_vpermt2varv16hi3_mask */
            }
          break;

        case E_V8HImode:
          if (pattern902 (x2, 
E_V8HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28140 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8665; /* *avx512vl_vpermi2varv8hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8737; /* avx512vl_vpermt2varv8hi3_mask */
            }
          break;

        case E_V64QImode:
          if (pattern902 (x2, 
E_V64QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28141 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8666; /* *avx512bw_vpermi2varv64qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8738; /* avx512bw_vpermt2varv64qi3_mask */
            }
          break;

        case E_V32QImode:
          if (pattern902 (x2, 
E_V32QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28142 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8667; /* *avx512vl_vpermi2varv32qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8739; /* avx512vl_vpermt2varv32qi3_mask */
            }
          break;

        case E_V16QImode:
          if (pattern902 (x2, 
E_V16QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8668; /* *avx512vl_vpermi2varv16qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8740; /* avx512vl_vpermt2varv16qi3_mask */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          if (rtx_equal_p (x9, operands[2]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1317 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8669; /* *avx512f_vpermi2varv16sf3_mask */
                  break;

                case E_V8SFmode:
                  if (pattern1317 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8670; /* *avx512vl_vpermi2varv8sf3_mask */
                  break;

                case E_V4SFmode:
                  if (pattern1317 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8671; /* *avx512vl_vpermi2varv4sf3_mask */
                  break;

                case E_V8DFmode:
                  if (pattern1317 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8672; /* *avx512f_vpermi2varv8df3_mask */
                  break;

                case E_V4DFmode:
                  if (pattern1317 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8673; /* *avx512vl_vpermi2varv4df3_mask */
                  break;

                case E_V2DFmode:
                  if (pattern1317 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8674; /* *avx512vl_vpermi2varv2df3_mask */
                  break;

                default:
                  break;
                }
            }
        }
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1160 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8724; /* avx512f_vpermt2varv16sf3_mask */

        case E_V8DFmode:
          if (pattern1160 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8726; /* avx512f_vpermt2varv8df3_mask */

        case E_V8SFmode:
          if (pattern1160 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8728; /* avx512vl_vpermt2varv8sf3_mask */

        case E_V4DFmode:
          if (pattern1160 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8730; /* avx512vl_vpermt2varv4df3_mask */

        case E_V4SFmode:
          if (pattern1160 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8732; /* avx512vl_vpermt2varv4sf3_mask */

        case E_V2DFmode:
          if (pattern1160 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8734; /* avx512vl_vpermt2varv2df3_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x5;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x6 = XEXP (x2, 2);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern421 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8676; /* avx512f_vpermt2varv16si3_maskz_1 */

        case E_V16SFmode:
          if (pattern1161 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8678; /* avx512f_vpermt2varv16sf3_maskz_1 */

        case E_V8DImode:
          if (pattern421 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8680; /* avx512f_vpermt2varv8di3_maskz_1 */

        case E_V8DFmode:
          if (pattern1161 (x2, 
E_V8DFmode, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8682; /* avx512f_vpermt2varv8df3_maskz_1 */

        case E_V8SImode:
          if (pattern421 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8684; /* avx512vl_vpermt2varv8si3_maskz_1 */

        case E_V8SFmode:
          if (pattern1161 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8686; /* avx512vl_vpermt2varv8sf3_maskz_1 */

        case E_V4DImode:
          if (pattern421 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8688; /* avx512vl_vpermt2varv4di3_maskz_1 */

        case E_V4DFmode:
          if (pattern1161 (x2, 
E_V4DFmode, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8690; /* avx512vl_vpermt2varv4df3_maskz_1 */

        case E_V4SImode:
          if (pattern421 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8692; /* avx512vl_vpermt2varv4si3_maskz_1 */

        case E_V4SFmode:
          if (pattern1161 (x2, 
E_V4SFmode, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8694; /* avx512vl_vpermt2varv4sf3_maskz_1 */

        case E_V2DImode:
          if (pattern421 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8696; /* avx512vl_vpermt2varv2di3_maskz_1 */

        case E_V2DFmode:
          if (pattern1161 (x2, 
E_V2DFmode, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8698; /* avx512vl_vpermt2varv2df3_maskz_1 */

        case E_V32HImode:
          if (pattern421 (x2, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8700; /* avx512bw_vpermt2varv32hi3_maskz_1 */

        case E_V16HImode:
          if (pattern421 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8702; /* avx512vl_vpermt2varv16hi3_maskz_1 */

        case E_V8HImode:
          if (pattern421 (x2, 
E_V8HImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8704; /* avx512vl_vpermt2varv8hi3_maskz_1 */

        case E_V64QImode:
          if (pattern421 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 8706; /* avx512bw_vpermt2varv64qi3_maskz_1 */

        case E_V32QImode:
          if (pattern421 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8708; /* avx512vl_vpermt2varv32qi3_maskz_1 */

        case E_V16QImode:
          if (pattern421 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8710; /* avx512vl_vpermt2varv16qi3_maskz_1 */

        case E_V32HFmode:
          if (pattern1161 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8712; /* avx512bw_vpermt2varv32hf3_maskz_1 */

        case E_V16HFmode:
          if (pattern1161 (x2, 
E_V16HFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8714; /* avx512vl_vpermt2varv16hf3_maskz_1 */

        case E_V8HFmode:
          if (pattern1161 (x2, 
E_V8HFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8716; /* avx512fp16_vpermt2varv8hf3_maskz_1 */

        case E_V32BFmode:
          if (pattern1161 (x2, 
E_V32BFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8718; /* avx512bw_vpermt2varv32bf3_maskz_1 */

        case E_V16BFmode:
          if (pattern1161 (x2, 
E_V16BFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8720; /* avx512vl_vpermt2varv16bf3_maskz_1 */

        case E_V8BFmode:
          if (pattern1161 (x2, 
E_V8BFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8722; /* avx512vl_vpermt2varv8bf3_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (pattern573 (x2))
    {
    case 0:
      if (pattern1260 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3372; /* fma_fnmadd_v32hf_maskz_1 */

    case 1:
      if (pattern1260 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3376; /* fma_fnmadd_v16hf_maskz_1 */

    case 2:
      if (pattern1260 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3378; /* fma_fnmadd_v8hf_maskz_1 */

    case 3:
      if (pattern1260 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5935 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3382; /* fma_fnmadd_v16sf_maskz_1 */

    case 4:
      if (pattern1260 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3386; /* fma_fnmadd_v8sf_maskz_1 */

    case 5:
      if (pattern1260 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3388; /* fma_fnmadd_v4sf_maskz_1 */

    case 6:
      if (pattern1260 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5937 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3391; /* fma_fnmadd_v8df_maskz_1 */

    case 7:
      if (pattern1260 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3395; /* fma_fnmadd_v4df_maskz_1 */

    case 8:
      if (pattern1260 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3397; /* fma_fnmadd_v2df_maskz_1 */

    case 9:
      if (pattern1261 (x2, 
E_SImode, 
E_V32BFmode) != 0
          || !
#line 32206 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9926; /* avx10_2_fnmaddbf16_v32bf_maskz_1 */

    case 10:
      if (pattern1261 (x2, 
E_HImode, 
E_V16BFmode) != 0
          || !
#line 32206 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9928; /* avx10_2_fnmaddbf16_v16bf_maskz_1 */

    case 11:
      if (pattern1261 (x2, 
E_QImode, 
E_V8BFmode) != 0
          || !
#line 32206 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9930; /* avx10_2_fnmaddbf16_v8bf_maskz_1 */

    case 12:
      if (pattern1262 (x2, 
E_V4SFmode) != 0
          || !
#line 6991 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4))
        return -1;
      return 3727; /* *fma4i_vmfnmadd_v4sf */

    case 13:
      if (pattern1262 (x2, 
E_V2DFmode) != 0
          || !(
#line 6991 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3728; /* *fma4i_vmfnmadd_v2df */

    case 14:
      if (pattern1179 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && vector_operand (operands[3], E_V32HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3398; /* avx512bw_fnmadd_v32hf_mask */
        }
      if (!vector_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3410; /* avx512bw_fnmadd_v32hf_mask3 */

    case 15:
      if (pattern1179 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[3], E_V16HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3400; /* avx512vl_fnmadd_v16hf_mask */
        }
      if (!vector_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3412; /* avx512vl_fnmadd_v16hf_mask3 */

    case 16:
      if (pattern1179 (x2, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[3], E_V8HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3401; /* avx512fp16_fnmadd_v8hf_mask */
        }
      if (!vector_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[3], E_V8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3413; /* avx512fp16_fnmadd_v8hf_mask3 */

    case 17:
      if (pattern1179 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && vector_operand (operands[3], E_V16SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3402; /* avx512f_fnmadd_v16sf_mask */
        }
      if (!vector_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3414; /* avx512f_fnmadd_v16sf_mask3 */

    case 18:
      if (pattern1179 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[3], E_V8SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3404; /* avx512vl_fnmadd_v8sf_mask */
        }
      if (!vector_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3416; /* avx512vl_fnmadd_v8sf_mask3 */

    case 19:
      if (pattern1179 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[3], E_V4SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3405; /* avx512vl_fnmadd_v4sf_mask */
        }
      if (!vector_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[3], E_V4SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3417; /* avx512vl_fnmadd_v4sf_mask3 */

    case 20:
      if (pattern1179 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && vector_operand (operands[3], E_V8DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3406; /* avx512f_fnmadd_v8df_mask */
        }
      if (!vector_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3418; /* avx512f_fnmadd_v8df_mask3 */

    case 21:
      if (pattern1179 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[3], E_V4DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3408; /* avx512vl_fnmadd_v4df_mask */
        }
      if (!vector_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3420; /* avx512vl_fnmadd_v4df_mask3 */

    case 22:
      if (pattern1179 (x2, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[3], E_V2DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3409; /* avx512vl_fnmadd_v2df_mask */
        }
      if (!vector_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3421; /* avx512vl_fnmadd_v2df_mask3 */

    case 23:
      if (pattern1180 (x2, 
E_SImode, 
E_V32BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9931; /* avx10_2_fnmaddbf16_v32bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9934; /* avx10_2_fnmaddbf16_v32bf_mask3 */

    case 24:
      if (pattern1180 (x2, 
E_HImode, 
E_V16BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9932; /* avx10_2_fnmaddbf16_v16bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9935; /* avx10_2_fnmaddbf16_v16bf_mask3 */

    case 25:
      if (pattern1180 (x2, 
E_QImode, 
E_V8BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9933; /* avx10_2_fnmaddbf16_v8bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9936; /* avx10_2_fnmaddbf16_v8bf_mask3 */

    case 26:
      if (pattern1263 (x2, 
E_V8HFmode) != 0
          || !(
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3639; /* *fmai_fnmadd_v8hf */

    case 27:
      if (pattern1263 (x2, 
E_V4SFmode) != 0
          || !
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
        return -1;
      return 3641; /* *fmai_fnmadd_v4sf */

    case 28:
      if (pattern1263 (x2, 
E_V2DFmode) != 0
          || !(
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3643; /* *fmai_fnmadd_v2df */

    case 29:
      return recog_143 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XEXP (x2, 2);
  if (!register_operand (x7, E_QImode))
    return -1;
  x8 = XVECEXP (x4, 0, 0);
  switch (XWINT (x8, 0))
    {
    case 2LL:
      x9 = XVECEXP (x4, 0, 1);
      if (XWINT (x9, 0) != 6LL
          || XWINT (x5, 0) != 3LL
          || XWINT (x6, 0) != 7LL)
        return -1;
      x10 = XEXP (x3, 0);
      x11 = XEXP (x10, 1);
      operands[2] = x11;
      x12 = XEXP (x2, 1);
      operands[3] = x12;
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1433 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11203 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL)))
            return -1;
          return 4576; /* vec_interleave_highv4sf_mask */

        case E_V4SImode:
          if (pattern1433 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19745 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7715; /* vec_interleave_highv4si_mask */

        default:
          return -1;
        }

    case 0LL:
      x9 = XVECEXP (x4, 0, 1);
      switch (XWINT (x9, 0))
        {
        case 4LL:
          switch (XWINT (x5, 0))
            {
            case 1LL:
              if (XWINT (x6, 0) != 5LL)
                return -1;
              x10 = XEXP (x3, 0);
              x11 = XEXP (x10, 1);
              operands[2] = x11;
              x12 = XEXP (x2, 1);
              operands[3] = x12;
              operands[4] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1432 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 11260 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 4581; /* unpcklps128_mask */

                case E_V4SImode:
                  if (pattern1433 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19799 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                    return -1;
                  return 7721; /* vec_interleave_lowv4si_mask */

                default:
                  return -1;
                }

            case 2LL:
              if (XWINT (x6, 0) != 6LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (pattern1485 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0)
                    return -1;
                  x12 = XEXP (x2, 1);
                  operands[2] = x12;
                  if (nonimmediate_operand (operands[1], E_V4DFmode))
                    {
                      operands[3] = x7;
                      x10 = XEXP (x3, 0);
                      x11 = XEXP (x10, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13455 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                        return 4736; /* avx_movddup256_mask */
                    }
                  operands[3] = x12;
                  if (!register_operand (operands[1], E_V4DFmode))
                    return -1;
                  x10 = XEXP (x3, 0);
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  if (!nonimmediate_operand (operands[2], E_V4DFmode))
                    return -1;
                  operands[4] = x7;
                  if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13469 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                    return -1;
                  return 4738; /* avx_unpcklpd256_mask */

                case E_V4DImode:
                  if (pattern1486 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
                    return -1;
                  return 6551; /* avx2_interleave_lowv4di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0LL:
          if (XWINT (x5, 0) != 6LL
              || XWINT (x6, 0) != 6LL
              || pattern1431 (x2) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11398 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_AVX512VL)))
            return -1;
          return 4592; /* sse3_movsldup_mask */

        default:
          return -1;
        }

    case 1LL:
      if (XWINT (x6, 0) != 7LL)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      switch (XWINT (x9, 0))
        {
        case 1LL:
          if (XWINT (x5, 0) != 7LL
              || pattern1431 (x2) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11345 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_AVX512VL)))
            return -1;
          return 4586; /* sse3_movshdup_mask */

        case 5LL:
          if (XWINT (x5, 0) != 3LL)
            return -1;
          x10 = XEXP (x3, 0);
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x2, 1);
          operands[3] = x12;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern1432 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13325 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                return -1;
              return 4728; /* avx_unpckhpd256_mask */

            case E_V4DImode:
              if (pattern1432 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14451 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
                return -1;
              return 6545; /* avx2_interleave_highv4di_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XVECEXP (x4, 0, 5);
  operands[7] = x8;
  x9 = XVECEXP (x4, 0, 6);
  operands[8] = x9;
  x10 = XVECEXP (x4, 0, 7);
  operands[9] = x10;
  x11 = XVECEXP (x4, 0, 8);
  operands[10] = x11;
  x12 = XVECEXP (x4, 0, 9);
  operands[11] = x12;
  x13 = XVECEXP (x4, 0, 10);
  operands[12] = x13;
  x14 = XVECEXP (x4, 0, 11);
  operands[13] = x14;
  x15 = XVECEXP (x4, 0, 12);
  operands[14] = x15;
  x16 = XVECEXP (x4, 0, 13);
  operands[15] = x16;
  x17 = XVECEXP (x4, 0, 14);
  operands[16] = x17;
  x18 = XVECEXP (x4, 0, 15);
  operands[17] = x18;
  x19 = XEXP (x2, 1);
  operands[18] = x19;
  x20 = XEXP (x2, 2);
  operands[19] = x20;
  if (!register_operand (operands[19], E_HImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || pattern1697 () != 0
          || !nonimm_or_0_operand (operands[18], E_V16SFmode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7777; /* *avx512f_shuf_f32x4_1_mask_1 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || GET_MODE (x3) != E_V16SImode
          || !nonimm_or_0_operand (operands[18], E_V16SImode))
        return -1;
      if (register_operand (operands[1], E_V16SImode)
          && pattern1697 () == 0
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7779; /* *avx512f_shuf_i32x4_1_mask_1 */
      if (!nonimmediate_operand (operands[1], E_V16SImode)
          || pattern1650 () != 0
          || !const_8_to_11_operand (operands[10], E_VOIDmode)
          || !const_8_to_11_operand (operands[11], E_VOIDmode)
          || !const_8_to_11_operand (operands[12], E_VOIDmode)
          || !const_8_to_11_operand (operands[13], E_VOIDmode)
          || !const_12_to_15_operand (operands[14], E_VOIDmode)
          || !const_12_to_15_operand (operands[15], E_VOIDmode)
          || !const_12_to_15_operand (operands[16], E_VOIDmode)
          || !const_12_to_15_operand (operands[17], E_VOIDmode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20535 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
   && INTVAL (operands[2]) + 8 == INTVAL (operands[10])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[11])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[12])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[13])
   && INTVAL (operands[2]) + 12 == INTVAL (operands[14])
   && INTVAL (operands[3]) + 12 == INTVAL (operands[15])
   && INTVAL (operands[4]) + 12 == INTVAL (operands[16])
   && INTVAL (operands[5]) + 12 == INTVAL (operands[17]))))
        return -1;
      return 7781; /* avx512f_pshufd_1_mask */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      return recog_129 (x1, insn, pnum_clobbers);

    case 2:
      return recog_128 (x1, insn, pnum_clobbers);

    case 3:
      return recog_127 (x1, insn, pnum_clobbers);

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 164:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1318 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4790; /* avx512f_vternlogv16si_maskz_1 */

                case E_V8SImode:
                  if (pattern1318 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4792; /* avx512vl_vternlogv8si_maskz_1 */

                case E_V4SImode:
                  if (pattern1318 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4794; /* avx512vl_vternlogv4si_maskz_1 */

                case E_V8DImode:
                  if (pattern1318 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4796; /* avx512f_vternlogv8di_maskz_1 */

                case E_V4DImode:
                  if (pattern1318 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4798; /* avx512vl_vternlogv4di_maskz_1 */

                case E_V2DImode:
                  if (pattern1318 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4800; /* avx512vl_vternlogv2di_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x2, 2);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1319 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6361; /* *avx512f_vternlogv16si_mask */

                case E_V8SImode:
                  if (pattern1319 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6362; /* *avx512vl_vternlogv8si_mask */

                case E_V4SImode:
                  if (pattern1319 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6363; /* *avx512vl_vternlogv4si_mask */

                case E_V8DImode:
                  if (pattern1319 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6364; /* *avx512f_vternlogv8di_mask */

                case E_V4DImode:
                  if (pattern1319 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6365; /* *avx512vl_vternlogv4di_mask */

                case E_V2DImode:
                  if (pattern1319 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6366; /* *avx512vl_vternlogv2di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 163:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1320 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6437; /* avx512f_fixupimmv16sf_maskz_1 */

                case E_V8SFmode:
                  if (pattern1320 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6441; /* avx512vl_fixupimmv8sf_maskz_1 */

                case E_V4SFmode:
                  if (pattern1320 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6445; /* avx512vl_fixupimmv4sf_maskz_1 */

                case E_V8DFmode:
                  if (pattern1320 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6449; /* avx512f_fixupimmv8df_maskz_1 */

                case E_V4DFmode:
                  if (pattern1320 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6453; /* avx512vl_fixupimmv4df_maskz_1 */

                case E_V2DFmode:
                  if (pattern1320 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6457; /* avx512vl_fixupimmv2df_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              x9 = XEXP (x2, 2);
              switch (GET_CODE (x9))
                {
                case REG:
                case SUBREG:
                  operands[5] = x9;
                  if (!rtx_equal_p (x8, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16SFmode:
                      if (pattern1368 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 6459; /* avx512f_fixupimmv16sf_mask */

                    case E_V8SFmode:
                      if (pattern1368 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6461; /* avx512vl_fixupimmv8sf_mask */

                    case E_V4SFmode:
                      if (pattern1368 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6463; /* avx512vl_fixupimmv4sf_mask */

                    case E_V8DFmode:
                      if (pattern1368 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 6465; /* avx512f_fixupimmv8df_mask */

                    case E_V4DFmode:
                      if (pattern1368 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6467; /* avx512vl_fixupimmv4df_mask */

                    case E_V2DFmode:
                      if (pattern1368 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6469; /* avx512vl_fixupimmv2df_mask */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x9, 0) != 1LL
                      || !rtx_equal_p (x8, operands[2]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern1369 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                          || !
#line 14180 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                        return -1;
                      return 6471; /* avx512f_sfixupimmv4sf */

                    case E_V2DFmode:
                      if (pattern1369 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                          || !(
#line 14180 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 6475; /* avx512f_sfixupimmv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern134 (x2))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 6992; /* ashlv16hi3_mask */
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8893; /* avx512vl_ashlvv16hi_mask */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 6996; /* ashlv8hi3_mask */
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8889; /* avx512vl_ashlvv8hi_mask */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7000; /* ashlv8si3_mask */
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8869; /* avx2_ashlvv8si_mask */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7004; /* ashlv4si3_mask */
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8873; /* avx2_ashlvv4si_mask */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7008; /* ashlv4di3_mask */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8881; /* avx2_ashlvv4di_mask */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7012; /* ashlv2di3_mask */
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8885; /* avx2_ashlvv2di_mask */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
        return 7032; /* ashlv32hi3_mask */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8897; /* avx512bw_ashlvv32hi_mask */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7036; /* ashlv16si3_mask */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 803 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8865; /* avx512f_ashlvv16si_mask */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7040; /* ashlv8di3_mask */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 804 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8877; /* avx512f_ashlvv8di_mask */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern119 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3169; /* *xorv8sf3_mask */

        case E_V4SFmode:
          if (pattern119 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 3175; /* *xorv4sf3_mask */

        case E_V4DFmode:
          if (pattern119 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3181; /* *xorv4df3_mask */

        case E_V2DFmode:
          if (pattern119 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3187; /* *xorv2df3_mask */

        case E_V16SFmode:
          if (pattern120 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3199; /* *xorv16sf3_mask */

        case E_V8DFmode:
          if (pattern120 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3205; /* *xorv8df3_mask */

        case E_V16SImode:
          if (pattern426 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7352; /* *xorv16si3_mask */

        case E_V8SImode:
          if (pattern426 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7358; /* *xorv8si3_mask */

        case E_V4SImode:
          if (pattern426 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V4SImode, operands))))
            return -1;
          return 7364; /* *xorv4si3_mask */

        case E_V8DImode:
          if (pattern426 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7370; /* *xorv8di3_mask */

        case E_V4DImode:
          if (pattern426 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7376; /* *xorv4di3_mask */

        case E_V2DImode:
          if (pattern426 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V2DImode, operands))))
            return -1;
          return 7382; /* *xorv2di3_mask */

        default:
          return -1;
        }

    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern918 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7300; /* one_cmplv16si2_mask */

        case E_V8DImode:
          if (pattern918 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7302; /* one_cmplv8di2_mask */

        case E_V8SImode:
          if (pattern918 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7310; /* one_cmplv8si2_mask */

        case E_V4SImode:
          if (pattern918 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode))))
            return -1;
          return 7312; /* one_cmplv4si2_mask */

        case E_V4DImode:
          if (pattern918 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7314; /* one_cmplv4di2_mask */

        case E_V2DImode:
          if (pattern918 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode))))
            return -1;
          return 7316; /* one_cmplv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern119 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3167; /* *iorv8sf3_mask */

    case E_V4SFmode:
      if (pattern119 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 3173; /* *iorv4sf3_mask */

    case E_V4DFmode:
      if (pattern119 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3179; /* *iorv4df3_mask */

    case E_V2DFmode:
      if (pattern119 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3185; /* *iorv2df3_mask */

    case E_V16SFmode:
      if (pattern120 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3197; /* *iorv16sf3_mask */

    case E_V8DFmode:
      if (pattern120 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3203; /* *iorv8df3_mask */

    case E_V16SImode:
      if (pattern426 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 7350; /* *iorv16si3_mask */

    case E_V8SImode:
      if (pattern426 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 7356; /* *iorv8si3_mask */

    case E_V4SImode:
      if (pattern426 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4SImode, operands))))
        return -1;
      return 7362; /* *iorv4si3_mask */

    case E_V8DImode:
      if (pattern426 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 7368; /* *iorv8di3_mask */

    case E_V4DImode:
      if (pattern426 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 7374; /* *iorv4di3_mask */

    case E_V2DImode:
      if (pattern426 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V2DImode, operands))))
        return -1;
      return 7380; /* *iorv2di3_mask */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 2915 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2354; /* avx_rcpv8sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 2915 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2355; /* sse_rcpv4sf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode)
          || !(
#line 2969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2358; /* avx512fp16_rcpv32hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !(
#line 2969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2360; /* avx512fp16_rcpv16hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !(
#line 2969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2362; /* avx512fp16_rcpv8hf2 */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32404 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9973; /* avx10_2_rcpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32404 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9975; /* avx10_2_rcpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32404 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9977; /* avx10_2_rcpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2243; /* avx512fp16_vmaddv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2251; /* sse_vmaddv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2259; /* sse2_vmaddv2df3_mask_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2247; /* avx512fp16_vmsubv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2255; /* sse_vmsubv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2263; /* sse2_vmsubv2df3_mask_round */

        default:
          return -1;
        }

    case MULT:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2309; /* avx512fp16_vmmulv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2317; /* sse_vmmulv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2325; /* sse2_vmmulv2df3_mask_round */

        default:
          return -1;
        }

    case DIV:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2313; /* avx512fp16_vmdivv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2321; /* sse_vmdivv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2329; /* sse2_vmdivv2df3_mask_round */

        default:
          return -1;
        }

    case SQRT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[4] = x9;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1402 (x2, 
E_V8HFmode) != 0
              || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2410; /* avx512fp16_vmsqrtv8hf2_mask_round */

        case E_V4SFmode:
          if (pattern1402 (x2, 
E_V4SFmode) != 0
              || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3086 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2414; /* sse_vmsqrtv4sf2_mask_round */

        case E_V2DFmode:
          if (pattern1402 (x2, 
E_V2DFmode) != 0
              || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2418; /* sse2_vmsqrtv2df2_mask_round */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SQRT:
          x6 = XEXP (x3, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1434 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                return -1;
              return 2422; /* *avx512fp16_vmsqrtv8hf2_mask_round */

            case E_V4SFmode:
              if (pattern1434 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3105 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                return -1;
              return 2426; /* *sse_vmsqrtv4sf2_mask_round */

            case E_V2DFmode:
              if (pattern1434 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                return -1;
              return 2430; /* *sse2_vmsqrtv2df2_mask_round */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_HFmode
              || pattern1101 (x3) != 0)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const48_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern1608 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4153; /* avx512fp16_vcvtsh2sd_mask_round */

            case E_V4SFmode:
              if (pattern1608 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4157; /* avx512fp16_vcvtsh2ss_mask_round */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (pattern1101 (x3) != 0
                  || pattern1336 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
                return -1;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (x12))
                {
                case E_DFmode:
                  if (!register_operand (operands[1], E_V2DFmode)
                      || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4165; /* avx512fp16_vcvtsd2sh_mask_round */

                case E_SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4169; /* avx512fp16_vcvtss2sh_mask_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[2] = x12;
              if (!nonimmediate_operand (operands[2], E_V2DFmode))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern1336 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              operands[1] = x8;
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              if (!nonimm_or_0_operand (operands[3], E_V4SFmode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_QImode)
                  || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9990 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 4496; /* sse2_cvtsd2ss_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2579; /* *avx512fp16_vmsmaxv8hf3_mask_round */

        case 1:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2587; /* *sse_vmsmaxv4sf3_mask_round */

        case 2:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2595; /* *sse2_vmsmaxv2df3_mask_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2583; /* *avx512fp16_vmsminv8hf3_mask_round */

        case 1:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2591; /* *sse_vmsminv4sf3_mask_round */

        case 2:
          if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2599; /* *sse2_vmsminv2df3_mask_round */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          switch (XINT (x5, 1))
            {
            case 63:
              switch (pattern1018 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2603; /* avx512fp16_ieee_vmmaxv8hf3_mask_round */

                case 1:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2611; /* sse_ieee_vmmaxv4sf3_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2619; /* sse2_ieee_vmmaxv2df3_mask_round */

                default:
                  return -1;
                }

            case 62:
              switch (pattern1018 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2607; /* avx512fp16_ieee_vmminv8hf3_mask_round */

                case 1:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2615; /* sse_ieee_vmminv4sf3_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2623; /* sse2_ieee_vmminv2df3_mask_round */

                default:
                  return -1;
                }

            case 221:
              if (pattern1019 (x2) != 0
                  || !(
#line 437 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 389 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3810; /* avx512fp16_fmulcsh_v8hf_mask_round */

            case 222:
              if (pattern1019 (x2) != 0
                  || !(
#line 437 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 389 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3814; /* avx512fp16_fcmulcsh_v8hf_mask_round */

            case 58:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1491 (x2))
                {
                case 0:
                  if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13598 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 4744; /* avx512f_vmscalefv8hf_mask_round */

                case 1:
                  if (!
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 4748; /* avx512f_vmscalefv4sf_mask_round */

                case 2:
                  if (!(
#line 421 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13598 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 4752; /* avx512f_vmscalefv2df_mask_round */

                default:
                  return -1;
                }

            case 165:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const48_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1491 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6406; /* avx512f_sgetexpv8hf_mask_round */

                case 1:
                  if (!
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6410; /* avx512f_sgetexpv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6414; /* avx512f_sgetexpv2df_mask_round */

                default:
                  return -1;
                }

            case 94:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[2] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[3] = x15;
              if (!const_0_to_255_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[1] = x10;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (pattern1578 (x2, 
E_V8HFmode) != 0
                      || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14225 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6522; /* avx512f_rndscalev8hf_mask_round */

                case E_V4SFmode:
                  if (pattern1578 (x2, 
E_V4SFmode) != 0
                      || !
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6526; /* avx512f_rndscalev4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1578 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14225 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6530; /* avx512f_rndscalev2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          switch (XINT (x5, 1))
            {
            case 192:
              switch (pattern1272 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2677; /* reducesv8hf_mask_round */

                case 1:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))))
                    return -1;
                  return 2681; /* reducesv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2685; /* reducesv2df_mask_round */

                default:
                  return -1;
                }

            case 217:
              switch (pattern1273 (x2))
                {
                case 0:
                  if (!(
#line 437 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 371 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3798; /* avx512fp16_fma_fmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3804; /* avx512fp16_fmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 219:
              switch (pattern1273 (x2))
                {
                case 0:
                  if (!(
#line 437 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 371 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3802; /* avx512fp16_fma_fcmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3806; /* avx512fp16_fcmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 194:
              if (XWINT (x6, 0) != 1LL
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1270 (x2, 
E_V4SFmode) != 0
                      || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ))))
                    return -1;
                  return 9270; /* avx512dq_rangesv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1270 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9274; /* avx512dq_rangesv2df_mask_round */

                default:
                  return -1;
                }

            case 166:
              if (XWINT (x6, 0) != 1LL
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              switch (pattern1271 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 9338; /* avx512f_vgetmantv8hf_mask_round */

                case 1:
                  if (!
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 9342; /* avx512f_vgetmantv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9346; /* avx512f_vgetmantv2df_mask_round */

                default:
                  return -1;
                }

            case 278:
              switch (pattern1272 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 10220; /* avx10_2_minmaxsv8hf_mask_round */

                case 1:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32658 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10224; /* avx10_2_minmaxsv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 10228; /* avx10_2_minmaxsv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          if (XINT (x5, 1) != 163)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          x17 = XVECEXP (x5, 0, 3);
          operands[4] = x17;
          if (!const_0_to_255_operand (operands[4], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x11, E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x6 = XEXP (x3, 2);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x4, 2);
              operands[6] = x9;
              if (!register_operand (operands[6], E_QImode))
                return -1;
              operands[7] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1609 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6474; /* avx512f_sfixupimmv4sf_maskz_1_round */

                case E_V2DFmode:
                  if (pattern1609 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 154 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14180 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6478; /* avx512f_sfixupimmv2df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[2]))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x6 = XEXP (x3, 2);
              operands[5] = x6;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              operands[6] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1610 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6480; /* avx512f_sfixupimmv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1610 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 6482; /* avx512f_sfixupimmv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      return recog_201 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x7 = XEXP (x5, 0);
      if (pattern818 (x7, 
2, 
E_V2SFmode) != 0)
        return -1;
      x18 = XEXP (x7, 1);
      x19 = XVECEXP (x18, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern1339 (x2) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      if (!nonimm_or_0_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[4] = x6;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const48_operand (operands[5], E_SImode)
          || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10034 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 4501; /* sse2_cvtss2sd_mask_round */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      if (register_operand (operands[0], E_V8HImode)
          && 
#line 29157 "../../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return 8953; /* vcvtps2ph256 */
      if (!memory_operand (operands[0], E_V8HImode)
          || !
#line 29169 "../../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return -1;
      return 8955; /* *vcvtps2ph256 */

    case E_V16HImode:
      if (GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16HImode)
          && 
#line 29208 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 8957; /* *avx512f_vcvtps2ph512 */
      if (!memory_operand (operands[0], E_V16HImode)
          || !
#line 29220 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8961; /* *avx512f_vcvtps2ph512 */

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern935 (x3, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9215; /* expandv16si_mask */

        case E_V16SFmode:
          if (pattern935 (x3, 
E_HImode, 
E_V16SFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9216; /* expandv16sf_mask */

        case E_V8DImode:
          if (pattern935 (x3, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9217; /* expandv8di_mask */

        case E_V8DFmode:
          if (pattern935 (x3, 
E_QImode, 
E_V8DFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9218; /* expandv8df_mask */

        case E_V8SImode:
          if (pattern935 (x3, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9219; /* expandv8si_mask */

        case E_V8SFmode:
          if (pattern935 (x3, 
E_QImode, 
E_V8SFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9220; /* expandv8sf_mask */

        case E_V4DImode:
          if (pattern935 (x3, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9221; /* expandv4di_mask */

        case E_V4DFmode:
          if (pattern935 (x3, 
E_QImode, 
E_V4DFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9222; /* expandv4df_mask */

        case E_V4SImode:
          if (pattern935 (x3, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9223; /* expandv4si_mask */

        case E_V4SFmode:
          if (pattern935 (x3, 
E_QImode, 
E_V4SFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9224; /* expandv4sf_mask */

        case E_V2DImode:
          if (pattern935 (x3, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9225; /* expandv2di_mask */

        case E_V2DFmode:
          if (pattern935 (x3, 
E_QImode, 
E_V2DFmode) != 0
              || !(
#line 29708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9226; /* expandv2df_mask */

        case E_V64QImode:
          if (pattern935 (x3, 
E_DImode, 
E_V64QImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9227; /* expandv64qi_mask */

        case E_V16QImode:
          if (pattern935 (x3, 
E_HImode, 
E_V16QImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9228; /* expandv16qi_mask */

        case E_V32QImode:
          if (pattern935 (x3, 
E_SImode, 
E_V32QImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9229; /* expandv32qi_mask */

        case E_V32HImode:
          if (pattern935 (x3, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9230; /* expandv32hi_mask */

        case E_V16HImode:
          if (pattern935 (x3, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9231; /* expandv16hi_mask */

        case E_V8HImode:
          if (pattern935 (x3, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 29722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9232; /* expandv8hi_mask */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern828 (x3))
        {
        case 0:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SImode)) >= 4)) && 
#line 1016 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9233; /* *expandv16si_mask */

        case 1:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SFmode)) >= 4)) && 
#line 1017 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9234; /* *expandv16sf_mask */

        case 2:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DImode)) >= 4)) && 
#line 1018 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9235; /* *expandv8di_mask */

        case 3:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DFmode)) >= 4)) && 
#line 1019 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9236; /* *expandv8df_mask */

        case 4:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SImode)) >= 4)) && 
#line 1020 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9237; /* *expandv8si_mask */

        case 5:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SFmode)) >= 4)) && 
#line 1020 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9238; /* *expandv8sf_mask */

        case 6:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DImode)) >= 4)) && 
#line 1021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9239; /* *expandv4di_mask */

        case 7:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DFmode)) >= 4)) && 
#line 1021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9240; /* *expandv4df_mask */

        case 8:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SImode)) >= 4)) && 
#line 1022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9241; /* *expandv4si_mask */

        case 9:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SFmode)) >= 4)) && 
#line 1022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9242; /* *expandv4sf_mask */

        case 10:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DImode)) >= 4)) && 
#line 1023 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9243; /* *expandv2di_mask */

        case 11:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DFmode)) >= 4)) && 
#line 1023 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9244; /* *expandv2df_mask */

        case 12:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V64QImode)) >= 4)) && 
#line 1024 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9245; /* *expandv64qi_mask */

        case 13:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16QImode)) >= 4)) && 
#line 1024 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9246; /* *expandv16qi_mask */

        case 14:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32QImode)) >= 4)) && 
#line 1024 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9247; /* *expandv32qi_mask */

        case 15:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32HImode)) >= 4)) && 
#line 1025 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9248; /* *expandv32hi_mask */

        case 16:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16HImode)) >= 4)) && 
#line 1025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9249; /* *expandv16hi_mask */

        case 17:
          if (!(
#line 29736 "../../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8HImode)) >= 4)) && 
#line 1025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9250; /* *expandv8hi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (pattern144 (x3, 
E_V16SFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9251; /* avx512dq_rangepv16sf */

    case E_V8SFmode:
      if (pattern144 (x3, 
E_V8SFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9255; /* avx512dq_rangepv8sf */

    case E_V4SFmode:
      if (pattern144 (x3, 
E_V4SFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9257; /* avx512dq_rangepv4sf */

    case E_V8DFmode:
      if (pattern144 (x3, 
E_V8DFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9259; /* avx512dq_rangepv8df */

    case E_V4DFmode:
      if (pattern144 (x3, 
E_V4DFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9263; /* avx512dq_rangepv4df */

    case E_V2DFmode:
      if (pattern144 (x3, 
E_V2DFmode) != 0
          || !(
#line 29802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9265; /* avx512dq_rangepv2df */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1))
    {
    case 0:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9468; /* vpshrd_v32hi */

    case 1:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9470; /* vpshrd_v16si */

    case 2:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9472; /* vpshrd_v8di */

    case 3:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9474; /* vpshrd_v16hi */

    case 4:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9476; /* vpshrd_v8si */

    case 5:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9478; /* vpshrd_v4di */

    case 6:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9480; /* vpshrd_v8hi */

    case 7:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9482; /* vpshrd_v4si */

    case 8:
      if (!(
#line 30386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9484; /* vpshrd_v2di */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 175:
      return recog_221 (x1, insn, pnum_clobbers);

    case 178:
      return recog_214 (x1, insn, pnum_clobbers);

    case 63:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2522; /* ieee_maxv32hf3 */

        case 1:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2530; /* ieee_maxv16hf3 */

        case 2:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2534; /* ieee_maxv8hf3 */

        case 3:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2538; /* ieee_maxv16sf3 */

        case 4:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2546; /* ieee_maxv8sf3 */

        case 5:
          if (!
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2550; /* ieee_maxv4sf3 */

        case 6:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2554; /* ieee_maxv8df3 */

        case 7:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2562; /* ieee_maxv4df3 */

        case 8:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2566; /* ieee_maxv2df3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2526; /* ieee_minv32hf3 */

        case 1:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2532; /* ieee_minv16hf3 */

        case 2:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2536; /* ieee_minv8hf3 */

        case 3:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2542; /* ieee_minv16sf3 */

        case 4:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2548; /* ieee_minv8sf3 */

        case 5:
          if (!
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2552; /* ieee_minv4sf3 */

        case 6:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2558; /* ieee_minv8df3 */

        case 7:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2564; /* ieee_minv4df3 */

        case 8:
          if (!(
#line 3397 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2568; /* ieee_minv2df3 */

        default:
          return -1;
        }

    case 192:
      return recog_220 (x1, insn, pnum_clobbers);

    case 221:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3779; /* avx512bw_fmulc_v32hf */

        case 1:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3787; /* avx512vl_fmulc_v16hf */

        case 2:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3791; /* avx512fp16_fmulc_v8hf */

        default:
          return -1;
        }

    case 222:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3783; /* avx512bw_fcmulc_v32hf */

        case 1:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3789; /* avx512vl_fcmulc_v16hf */

        case 2:
          if (!(
#line 7322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3793; /* avx512fp16_fcmulc_v8hf */

        default:
          return -1;
        }

    case 58:
      return recog_222 (x1, insn, pnum_clobbers);

    case 94:
      return recog_217 (x1, insn, pnum_clobbers);

    case 188:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern154 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 16657 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6936; /* avx512bw_pmaddwd512v32hi */

        case E_V8SImode:
          if (pattern154 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 16657 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6938; /* avx512bw_pmaddwd512v16hi */

        case E_V4SImode:
          if (pattern154 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 16657 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1))
            return -1;
          return 6940; /* avx512bw_pmaddwd512v8hi */

        default:
          return -1;
        }

    case 57:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern672 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 19362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7656; /* avx512bw_packuswb */

        case E_V32QImode:
          if (pattern672 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 19362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7658; /* avx2_packuswb */

        case E_V16QImode:
          if (pattern672 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 19362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7660; /* sse2_packuswb */

        case E_V32HImode:
          if (pattern672 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 23831 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8022; /* avx512bw_packusdw */

        case E_V16HImode:
          if (pattern672 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 23831 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8024; /* avx2_packusdw */

        case E_V8HImode:
          if (pattern672 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 23831 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return -1;
          return 8026; /* sse4_1_packusdw */

        default:
          return -1;
        }

    case 190:
      if (pattern148 (x1) != 0
          || !
#line 20701 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7786; /* *avx512bw_pshuflwv32hi */

    case 189:
      if (pattern148 (x1) != 0
          || !
#line 20877 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7792; /* *avx512bw_pshufhwv32hi */

    case 56:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DImode:
          if (pattern715 (x2, 
E_V64QImode, 
E_V8DImode) != 0
              || !(
#line 21904 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 701 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7841; /* *avx512f_psadbw */

        case E_V4DImode:
          if (pattern715 (x2, 
E_V32QImode, 
E_V4DImode) != 0
              || !(
#line 21904 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 701 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7842; /* *avx2_psadbw */

        case E_V2DImode:
          if (pattern715 (x2, 
E_V16QImode, 
E_V2DImode) != 0
              || !
#line 21904 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 7843; /* *sse2_psadbw */

        default:
          return -1;
        }

    case 187:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern154 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 22782 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7900; /* avx512bw_pmaddubsw512v8hi */

        case E_V16HImode:
          if (pattern154 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 22782 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7902; /* avx512bw_pmaddubsw512v16hi */

        case E_V32HImode:
          if (pattern154 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 22782 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7904; /* avx512bw_pmaddubsw512v32hi */

        default:
          return -1;
        }

    case 52:
      switch (pattern149 (x1))
        {
        case 0:
          if (!(
#line 23107 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7918; /* avx512bw_pshufbv64qi3 */

        case 1:
          if (!(
#line 23107 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7920; /* avx2_pshufbv32qi3 */

        case 2:
          if (!
#line 23107 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1))
            return -1;
          return 7922; /* ssse3_pshufbv16qi3 */

        default:
          return -1;
        }

    case 120:
      return recog_225 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern150 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 23437 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 7970; /* sse4a_extrq */

    case 125:
      if (pattern71 (x1, 
E_V2DImode) != 0
          || !
#line 23463 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 7972; /* sse4a_insertq */

    case 130:
      return recog_216 (x1, insn, pnum_clobbers);

    case 137:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27088 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8375; /* aesenc */

    case 138:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27106 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8376; /* aesenclast */

    case 139:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27124 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8377; /* aesdec */

    case 140:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27142 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8378; /* aesdeclast */

    case 142:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vector_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode)
          || !
#line 27172 "../../../gcc/config/i386/sse.md"
(TARGET_AES))
        return -1;
      return 8380; /* aeskeygenassist */

    case 151:
      return recog_218 (x1, insn, pnum_clobbers);

    case 144:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern718 (x2, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8645; /* avx512f_vpermilvarv16sf3 */

        case E_V8SFmode:
          if (pattern718 (x2, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8647; /* avx_vpermilvarv8sf3 */

        case E_V4SFmode:
          if (pattern718 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 8649; /* avx_vpermilvarv4sf3 */

        case E_V8DFmode:
          if (pattern718 (x2, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8651; /* avx512f_vpermilvarv8df3 */

        case E_V4DFmode:
          if (pattern718 (x2, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8653; /* avx_vpermilvarv4df3 */

        case E_V2DFmode:
          if (pattern718 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 28112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 376 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8655; /* avx_vpermilvarv2df3 */

        default:
          return -1;
        }

    case 47:
      return recog_223 (x1, insn, pnum_clobbers);

    case 150:
      return recog_224 (x1, insn, pnum_clobbers);

    case 160:
      return recog_215 (x1, insn, pnum_clobbers);

    case 166:
      return recog_219 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9377; /* sha1msg1 */

    case 180:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29959 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9378; /* sha1msg2 */

    case 181:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29970 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9379; /* sha1nexte */

    case 183:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29994 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9381; /* sha256msg1 */

    case 184:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 30005 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9382; /* sha256msg2 */

    case 239:
      if (pattern150 (x1, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 30067 "../../../gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9387; /* vsha512msg1 */

    case 240:
      if (pattern71 (x1, 
E_V4DImode) != 0
          || !
#line 30078 "../../../gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9388; /* vsha512msg2 */

    case 242:
      switch (pattern152 (x1))
        {
        case 0:
          if (!(
#line 30101 "../../../gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9390; /* vsm4key4_v16si */

        case 1:
          if (!
#line 30101 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9391; /* vsm4key4_v8si */

        case 2:
          if (!
#line 30101 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9392; /* vsm4key4_v4si */

        default:
          return -1;
        }

    case 243:
      switch (pattern152 (x1))
        {
        case 0:
          if (!(
#line 30114 "../../../gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9393; /* vsm4rnds4_v16si */

        case 1:
          if (!
#line 30114 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9394; /* vsm4rnds4_v8si */

        case 2:
          if (!
#line 30114 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9395; /* vsm4rnds4_v4si */

        default:
          return -1;
        }

    case 197:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern64 (x2, 
E_V64QImode) != 0
              || !(
#line 30260 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9420; /* vpmultishiftqbv64qi */

        case E_V16QImode:
          if (pattern64 (x2, 
E_V16QImode) != 0
              || !(
#line 30260 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9422; /* vpmultishiftqbv16qi */

        case E_V32QImode:
          if (pattern64 (x2, 
E_V32QImode) != 0
              || !(
#line 30260 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9424; /* vpmultishiftqbv32qi */

        default:
          return -1;
        }

    case 200:
      switch (pattern149 (x1))
        {
        case 0:
          if (!(
#line 30369 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9462; /* vgf2p8mulb_v64qi */

        case 1:
          if (!(
#line 30369 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9464; /* vgf2p8mulb_v32qi */

        case 2:
          if (!
#line 30369 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 9466; /* vgf2p8mulb_v16qi */

        default:
          return -1;
        }

    case 209:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9594; /* vaesdec_v32qi */

        case 1:
          if (!(
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9595; /* vaesdec_v16qi */

        case 2:
          if (!(
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9596; /* vaesdec_v64qi */

        default:
          return -1;
        }

    case 210:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30863 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9597; /* vaesdeclast_v32qi */

        case 1:
          if (!(
#line 30863 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9598; /* vaesdeclast_v16qi */

        case 2:
          if (!(
#line 30863 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9599; /* vaesdeclast_v64qi */

        default:
          return -1;
        }

    case 211:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30881 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9600; /* vaesenc_v32qi */

        case 1:
          if (!(
#line 30881 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9601; /* vaesenc_v16qi */

        case 2:
          if (!(
#line 30881 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9602; /* vaesenc_v64qi */

        default:
          return -1;
        }

    case 212:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30899 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9603; /* vaesenclast_v32qi */

        case 1:
          if (!(
#line 30899 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9604; /* vaesenclast_v16qi */

        case 2:
          if (!(
#line 30899 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9605; /* vaesenclast_v64qi */

        default:
          return -1;
        }

    case 249:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9730; /* vcvt2ph2bf8v32hf */

        case 1:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9738; /* vcvt2ph2bf8v16hf */

        case 2:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9746; /* vcvt2ph2bf8v8hf */

        default:
          return -1;
        }

    case 250:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9732; /* vcvt2ph2bf8sv32hf */

        case 1:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9740; /* vcvt2ph2bf8sv16hf */

        case 2:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9748; /* vcvt2ph2bf8sv8hf */

        default:
          return -1;
        }

    case 251:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9734; /* vcvt2ph2hf8v32hf */

        case 1:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9742; /* vcvt2ph2hf8v16hf */

        case 2:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9750; /* vcvt2ph2hf8v8hf */

        default:
          return -1;
        }

    case 252:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9736; /* vcvt2ph2hf8sv32hf */

        case 1:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9744; /* vcvt2ph2hf8sv16hf */

        case 2:
          if (!
#line 31736 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9752; /* vcvt2ph2hf8sv8hf */

        default:
          return -1;
        }

    case 245:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9762; /* vcvtbiasph2bf8v32hf */

        case 1:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9770; /* vcvtbiasph2bf8v16hf */

        default:
          return -1;
        }

    case 246:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9764; /* vcvtbiasph2bf8sv32hf */

        case 1:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9772; /* vcvtbiasph2bf8sv16hf */

        default:
          return -1;
        }

    case 247:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9766; /* vcvtbiasph2hf8v32hf */

        case 1:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9774; /* vcvtbiasph2hf8v16hf */

        default:
          return -1;
        }

    case 248:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9768; /* vcvtbiasph2hf8sv32hf */

        case 1:
          if (!
#line 31825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9776; /* vcvtbiasph2hf8sv16hf */

        default:
          return -1;
        }

    case 258:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern64 (x2, 
E_V32BFmode) != 0
              || !
#line 32092 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9871; /* avx10_2_scalefbf16_v32bf */

        case E_V16BFmode:
          if (pattern64 (x2, 
E_V16BFmode) != 0
              || !
#line 32092 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9873; /* avx10_2_scalefbf16_v16bf */

        case E_V8BFmode:
          if (pattern64 (x2, 
E_V8BFmode) != 0
              || !
#line 32092 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9875; /* avx10_2_scalefbf16_v8bf */

        default:
          return -1;
        }

    case 259:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9985; /* avx10_2_rndscalebf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9991; /* avx10_2_rndscalebf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9997; /* avx10_2_rndscalebf16_v8bf */

        default:
          return -1;
        }

    case 260:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9987; /* avx10_2_reducebf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9993; /* avx10_2_reducebf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9999; /* avx10_2_reducebf16_v8bf */

        default:
          return -1;
        }

    case 261:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9989; /* avx10_2_getmantbf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9995; /* avx10_2_getmantbf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10001; /* avx10_2_getmantbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_270 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_272 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0LL
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || !register_operand (operands[0], E_V8HImode)
      || GET_MODE (x2) != E_V8HImode
      || !vector_operand (operands[1], E_V8HImode)
      || pattern1348 (x3) != 0
      || !
#line 20991 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
    return -1;
  return 7796; /* sse2_pshufhw_1 */
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[6] = x4;
  res = recog_275 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern1290 (x3) != 0
      || !register_operand (operands[0], E_V16HImode)
      || GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], E_V16HImode)
      || pattern608 (x3) != 0)
    return -1;
  x8 = XVECEXP (x3, 0, 8);
  operands[6] = x8;
  if (!const_8_to_11_operand (operands[6], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 9);
  operands[7] = x9;
  if (!const_8_to_11_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 10);
  operands[8] = x10;
  if (!const_8_to_11_operand (operands[8], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 11);
  operands[9] = x11;
  if (!const_8_to_11_operand (operands[9], E_VOIDmode)
      || !
#line 20768 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && 1 && 1
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9])))
    return -1;
  return 7788; /* avx2_pshuflw_1 */
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BFmode:
      if (GET_MODE (x2) != E_V16BFmode)
        return -1;
      if (register_operand (operands[0], E_V16BFmode)
          && vector_operand (operands[1], E_V16BFmode)
          && vector_operand (operands[2], E_V16BFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3152; /* *andv16bf3 */
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16BFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3207; /* *bit_and_float_vector_all_ones */

    case E_V8BFmode:
      if (GET_MODE (x2) != E_V8BFmode)
        return -1;
      if (register_operand (operands[0], E_V8BFmode)
          && vector_operand (operands[1], E_V8BFmode)
          && vector_operand (operands[2], E_V8BFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3155; /* *andv8bf3 */
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8BFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3208; /* *bit_and_float_vector_all_ones */

    case E_V16HFmode:
      if (GET_MODE (x2) != E_V16HFmode)
        return -1;
      if (register_operand (operands[0], E_V16HFmode)
          && vector_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[2], E_V16HFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3158; /* *andv16hf3 */
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16HFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3210; /* *bit_and_float_vector_all_ones */

    case E_V8HFmode:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      if (register_operand (operands[0], E_V8HFmode)
          && vector_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[2], E_V8HFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3161; /* *andv8hf3 */
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8HFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3211; /* *bit_and_float_vector_all_ones */

    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      if (register_operand (operands[0], E_V8SFmode)
          && vector_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[2], E_V8SFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3164; /* *andv8sf3 */
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8SFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3213; /* *bit_and_float_vector_all_ones */

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (register_operand (operands[0], E_V4SFmode)
          && vector_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[2], E_V4SFmode)
          && 
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 3170; /* *andv4sf3 */
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()))
        return -1;
      return 3214; /* *bit_and_float_vector_all_ones */

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      if (register_operand (operands[0], E_V4DFmode)
          && vector_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[2], E_V4DFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3176; /* *andv4df3 */
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4DFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3216; /* *bit_and_float_vector_all_ones */

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (register_operand (operands[0], E_V2DFmode)
          && vector_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[2], E_V2DFmode)
          && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3182; /* *andv2df3 */
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V2DFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3217; /* *bit_and_float_vector_all_ones */

    case E_V32BFmode:
      if (GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      if (register_operand (operands[0], E_V32BFmode)
          && nonimmediate_operand (operands[2], E_V32BFmode)
          && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 491 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3188; /* *andv32bf3 */
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32BFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 411 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3206; /* *bit_and_float_vector_all_ones */

    case E_V32HFmode:
      if (GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      if (register_operand (operands[0], E_V32HFmode)
          && nonimmediate_operand (operands[2], E_V32HFmode)
          && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3191; /* *andv32hf3 */
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32HFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3209; /* *bit_and_float_vector_all_ones */

    case E_V16SFmode:
      if (GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16SFmode)
          && nonimmediate_operand (operands[2], E_V16SFmode)
          && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3194; /* *andv16sf3 */
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16SFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3212; /* *bit_and_float_vector_all_ones */

    case E_V8DFmode:
      if (GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      if (register_operand (operands[0], E_V8DFmode)
          && nonimmediate_operand (operands[2], E_V8DFmode)
          && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3200; /* *andv8df3 */
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8DFmode)
          || !(
#line 5474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3215; /* *bit_and_float_vector_all_ones */

    case E_V16SImode:
      if (pattern173 (x2, 
E_V16SImode) != 0
          || !(
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7347; /* *andv16si3 */

    case E_V8SImode:
      if (pattern173 (x2, 
E_V8SImode) != 0
          || !(
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7353; /* *andv8si3 */

    case E_V4SImode:
      if (pattern173 (x2, 
E_V4SImode) != 0
          || !
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4SImode, operands)))
        return -1;
      return 7359; /* *andv4si3 */

    case E_V8DImode:
      if (pattern173 (x2, 
E_V8DImode) != 0
          || !(
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7365; /* *andv8di3 */

    case E_V4DImode:
      if (pattern173 (x2, 
E_V4DImode) != 0
          || !(
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7371; /* *andv4di3 */

    case E_V2DImode:
      if (pattern173 (x2, 
E_V2DImode) != 0
          || !
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V2DImode, operands)))
        return -1;
      return 7377; /* *andv2di3 */

    case E_V64QImode:
      if (pattern26 (x2, 
E_V64QImode) != 0
          || !(
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7383; /* *andv64qi3 */

    case E_V32QImode:
      if (pattern26 (x2, 
E_V32QImode) != 0
          || !(
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7386; /* *andv32qi3 */

    case E_V16QImode:
      if (pattern26 (x2, 
E_V16QImode) != 0
          || !
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7389; /* *andv16qi3 */

    case E_V32HImode:
      if (pattern26 (x2, 
E_V32HImode) != 0
          || !(
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7392; /* *andv32hi3 */

    case E_V16HImode:
      if (pattern26 (x2, 
E_V16HImode) != 0
          || !(
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7395; /* *andv16hi3 */

    case E_V8HImode:
      if (pattern26 (x2, 
E_V8HImode) != 0
          || !
#line 18819 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7398; /* *andv8hi3 */

    case E_V1TImode:
      if (pattern604 (x2, 
E_V1TImode) != 0
          || !
#line 18916 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7401; /* andv1ti3 */

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5191; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5218; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5245; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5272; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5299; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5326; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5353; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5380; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5407; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5434; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5461; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5488; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5194; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5221; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5248; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5275; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5302; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5329; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5356; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5383; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5410; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5437; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5464; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5491; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5197; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5224; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5251; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5278; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5305; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5332; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5359; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5386; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5413; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5440; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5467; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5494; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6259; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6268; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6277; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6286; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6295; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6304; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6313; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6322; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6331; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6340; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6349; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6358; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5839; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5866; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5893; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5920; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5947; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5974; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6001; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6028; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6055; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6082; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6109; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6136; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5842; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5869; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5896; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5923; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5950; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5977; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6004; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6031; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6058; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6085; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6112; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6139; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5845; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5872; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5899; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5926; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5953; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5980; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6007; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6034; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6061; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6088; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6115; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6142; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_252 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          switch (pattern288 (x3, 
PLUS))
            {
            case 0:
              if (!
#line 3670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2628; /* avx_haddv4df3 */

            case 1:
              if (!
#line 3846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2636; /* sse3_haddv4sf3 */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern288 (x3, 
MINUS))
            {
            case 0:
              if (!
#line 3670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2629; /* avx_hsubv4df3 */

            case 1:
              if (!
#line 3846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2637; /* sse3_hsubv4sf3 */

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != VEC_CONCAT
              || GET_MODE (x6) != E_V2SFmode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != VEC_CONCAT
              || GET_MODE (x7) != E_V4SFmode
              || pattern937 (x7, 
E_V2SFmode, 
VEC_CONCAT) != 0
              || !register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x4) != E_V4SFmode
              || pattern1406 (x3, 
E_SFmode) != 0)
            return -1;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern1657 (x3, 
PLUS) != 0
                  || !
#line 3818 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2634; /* avx_haddv8sf3 */

            case MINUS:
              if (pattern1657 (x3, 
MINUS) != 0
                  || !
#line 3818 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2635; /* avx_hsubv8sf3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (pattern351 (x3) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1343 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !(
#line 30128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9396; /* avx512f_si512_si */

            case E_V16SFmode:
              if (pattern1343 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !(
#line 30128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9397; /* avx512f_ps512_ps */

            case E_V8DFmode:
              if (pattern1343 (x3, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !(
#line 30128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9398; /* avx512f_pd512_pd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern92 (x3, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode)
          || pattern1693 (x3) != 0
          || !
#line 3709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 2630; /* *sse3_haddv2df3 */

    case MINUS:
      if (pattern93 (x4, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x7) != E_DFmode
          || pattern1407 (x7, 
E_DFmode) != 0
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode))
        return -1;
      x6 = XEXP (x4, 1);
      x11 = XEXP (x6, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      x13 = XEXP (x12, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 3734 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
        return -1;
      return 2631; /* sse3_hsubv2df3 */

    case FLOAT:
      switch (pattern171 (x3))
        {
        case 0:
          if (!
#line 7682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3935; /* *avx512fp16_vcvtdq2ph_v4si */

        case 1:
          if (!
#line 7682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3937; /* *avx512fp16_vcvtqq2ph_v4di */

        case 2:
          if (!
#line 7758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3947; /* *avx512fp16_vcvtqq2ph_v2di */

        case 3:
          if (!
#line 9194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4334; /* *avx512dq_floatv2div2sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern171 (x3))
        {
        case 0:
          if (!
#line 7682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3936; /* *avx512fp16_vcvtudq2ph_v4si */

        case 1:
          if (!
#line 7682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3938; /* *avx512fp16_vcvtuqq2ph_v4di */

        case 2:
          if (!
#line 7758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 3948; /* *avx512fp16_vcvtuqq2ph_v2di */

        case 3:
          if (!
#line 9194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4335; /* *avx512dq_floatunsv2div2sf2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_251 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4HFmode:
                  if (!const0_operand (operands[2], E_V4HFmode))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4DFmode:
                      if (!vector_operand (operands[1], E_V4DFmode)
                          || !
#line 8149 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4141; /* *avx512fp16_vcvtpd2ph_v4df */

                    case E_V4SFmode:
                      if (!vector_operand (operands[1], E_V4SFmode)
                          || !
#line 8149 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4142; /* *avx512fp16_vcvtps2ph_v4sf */

                    default:
                      return -1;
                    }

                case E_V2HFmode:
                  if (!vector_operand (operands[1], E_V2DFmode)
                      || !const0_operand (operands[2], E_V6HFmode)
                      || !
#line 8228 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4147; /* *avx512fp16_vcvtpd2ph_v2df */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V2SFmode
                  || !vector_operand (operands[1], E_V2DFmode)
                  || !const0_operand (operands[2], E_V2SFmode)
                  || !
#line 10119 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4509; /* *sse2_cvtpd2ps */

            case E_V8BFmode:
              if (pattern170 (x3, 
E_V4BFmode, 
E_V4SFmode, 
E_V8BFmode) != 0
                  || !
#line 31054 "../../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
                return -1;
              return 9629; /* *vcvtneps2bf16_v4sf */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32BFmode:
              if (pattern725 (x3, 
E_V16SFmode, 
E_V16BFmode, 
E_V32BFmode) != 0
                  || !(
#line 31015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30981 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9623; /* avx512f_cvtne2ps2bf16_v32bf */

            case E_V16BFmode:
              if (pattern725 (x3, 
E_V8SFmode, 
E_V8BFmode, 
E_V16BFmode) != 0
                  || !(
#line 31015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30981 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9625; /* avx512f_cvtne2ps2bf16_v16bf */

            case E_V8BFmode:
              if (pattern725 (x3, 
E_V4SFmode, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 31015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30981 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9627; /* avx512f_cvtne2ps2bf16_v8bf */

            case E_V32HFmode:
              if (pattern726 (x3, 
E_V16SFmode, 
E_V16HFmode, 
E_V32HFmode) != 0
                  || !(
#line 31714 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 9722; /* avx10_2_cvt2ps2phx_v32hf */

            case E_V16HFmode:
              if (pattern726 (x3, 
E_V8SFmode, 
E_V8HFmode, 
E_V16HFmode) != 0
                  || !
#line 31714 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 9726; /* avx10_2_cvt2ps2phx_v16hf */

            case E_V8HFmode:
              if (pattern726 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !
#line 31714 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 9728; /* avx10_2_cvt2ps2phx_v8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_253 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || XVECLEN (x7, 0) != 2
          || GET_MODE (x7) != E_V2SImode
          || pattern13 (x3, 
E_V2DFmode, 
E_V4SImode, 
0) != 0
          || !
#line 9580 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 4388; /* *fixuns_truncv2dfv2si2 */

    case FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || pattern449 (x7, 
E_V2SImode, 
2) != 0
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 9938 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4490; /* sse2_cvttpd2dq */

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          res = recog_249 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_250 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          if (XVECLEN (x7, 0) == 1
              && XINT (x7, 1) == 147)
            {
              x14 = XVECEXP (x7, 0, 0);
              if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  operands[1] = x4;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern938 (x3, 
E_V4SImode, 
E_V8SImode) == 0
                          && 
#line 28802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8843; /* avx_si256_si */
                      break;

                    case E_V8SFmode:
                      if (pattern938 (x3, 
E_V4SFmode, 
E_V8SFmode) == 0
                          && 
#line 28802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8844; /* avx_ps256_ps */
                      break;

                    case E_V4DFmode:
                      if (pattern938 (x3, 
E_V2DFmode, 
E_V4DFmode) == 0
                          && 
#line 28802 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8845; /* avx_pd256_pd */
                      break;

                    case E_V16SImode:
                      if (pattern938 (x3, 
E_V8SImode, 
E_V16SImode) == 0
                          && (
#line 30145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9399; /* avx512f_si512_256si */
                      break;

                    case E_V16SFmode:
                      if (pattern938 (x3, 
E_V8SFmode, 
E_V16SFmode) == 0
                          && (
#line 30145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9400; /* avx512f_ps512_256ps */
                      break;

                    case E_V8DFmode:
                      if (pattern938 (x3, 
E_V4DFmode, 
E_V8DFmode) == 0
                          && (
#line 30145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9401; /* avx512f_pd512_256pd */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern544 (x3) == 0)
        {
          x5 = XEXP (x4, 0);
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          if (memory_operand (operands[1], E_V16QImode))
            {
              x9 = XEXP (x7, 0);
              x16 = XVECEXP (x9, 0, 0);
              if (rtx_equal_p (x16, operands[1])
                  && 
#line 27899 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()))
                return 8590; /* avx2_lddqu_inserti_to_bcasti */
            }
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      if (rtx_equal_p (x7, operands[1])
          && 
#line 27991 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return 8608; /* avx_vbroadcastf128_v4di */
      operands[2] = x7;
      if (!nonimm_or_0_operand (operands[2], E_V2DImode)
          || !
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8905; /* avx_vec_concatv4di */

    case ZERO_EXTEND:
      switch (pattern172 (x3))
        {
        case 0:
          if (!
#line 12083 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4642; /* *vec_setv2di_0_zero_extendhi_1 */

        case 1:
          if (!
#line 12197 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 4654; /* *vec_setv2di_0_zero_extendsi_1 */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          switch (pattern451 (x3))
            {
            case 0:
              if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6627; /* avx512vl_ss_truncatev4div4qi2 */
              break;

            case 1:
              if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6636; /* avx512vl_ss_truncatev4siv4qi2 */
              break;

            case 2:
              if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6630; /* avx512vl_ss_truncatev2div2qi2 */
              break;

            case 3:
              if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6633; /* avx512vl_ss_truncatev8siv8qi2 */
              break;

            case 4:
              if ((
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 6639; /* avx512vl_ss_truncatev8hiv8qi2 */
              break;

            case 5:
              if ((
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return 6718; /* avx512vl_ss_truncatev4div4hi2 */
              break;

            case 6:
              if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6724; /* avx512vl_ss_truncatev4siv4hi2 */
              break;

            case 7:
              if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6721; /* avx512vl_ss_truncatev2div2hi2 */
              break;

            case 8:
              if (
#line 15949 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6773; /* avx512vl_ss_truncatev2div2si2 */
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != CONST_VECTOR
              || pattern449 (x7, 
E_V8QImode, 
8) != 0)
            return -1;
          x17 = XVECEXP (x7, 0, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x7, 0, 3);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x7, 0, 4);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x7, 0, 5);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x7, 0, 6);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x22 = XVECEXP (x7, 0, 7);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern777 (x3, 
E_V8DImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 16085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6792; /* avx512f_ss_truncatev8div16qi2 */

        case SS_TRUNCATE:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern731 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 19198 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7644; /* sse2_packsswb */

            case E_V8HImode:
              if (pattern731 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 19292 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7650; /* sse2_packssdw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern451 (x3))
        {
        case 0:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6628; /* avx512vl_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6637; /* avx512vl_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6631; /* avx512vl_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6634; /* avx512vl_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6640; /* avx512vl_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6719; /* avx512vl_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6725; /* avx512vl_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6722; /* avx512vl_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15949 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6774; /* avx512vl_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern452 (x3) != 0
          || !
#line 16085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6793; /* avx512f_truncatev8div16qi2 */

    case US_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern451 (x3))
        {
        case 0:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6629; /* avx512vl_us_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6638; /* avx512vl_us_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6632; /* avx512vl_us_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6635; /* avx512vl_us_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15353 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6641; /* avx512vl_us_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6720; /* avx512vl_us_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6726; /* avx512vl_us_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6723; /* avx512vl_us_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15949 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6775; /* avx512vl_us_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern452 (x3) != 0
          || !
#line 16085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6794; /* avx512f_us_truncatev8div16qi2 */

    default:
      return -1;
    }
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern50 (x3))
        {
        case 0:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6858; /* *avx512bw_ssaddv64qi3 */

        case 1:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6866; /* *avx2_ssaddv32qi3 */

        case 2:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands)))
            return -1;
          return 6874; /* *sse2_ssaddv16qi3 */

        case 3:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6882; /* *avx512bw_ssaddv32hi3 */

        case 4:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6890; /* *avx2_ssaddv16hi3 */

        case 5:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands)))
            return -1;
          return 6898; /* *sse2_ssaddv8hi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern187 (x3))
        {
        case 0:
          if (!
#line 22557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7882; /* avx2_phaddswv16hi3 */

        case 1:
          if (!
#line 22580 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7886; /* ssse3_phaddswv8hi3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL)
            return -1;
          x11 = XEXP (x3, 1);
          if (GET_CODE (x11) != MULT)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_SELECT)
            return -1;
          x14 = XEXP (x13, 1);
          if (GET_CODE (x14) != PARALLEL)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != SIGN_EXTEND)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != VEC_SELECT)
            return -1;
          x17 = XEXP (x16, 1);
          if (GET_CODE (x17) != PARALLEL)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          x19 = XEXP (x9, 0);
          operands[2] = x19;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x16, 0);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 16:
              if (pattern974 (x7, 
6, 
4, 
2, 
0) != 0)
                return -1;
              x22 = XVECEXP (x7, 0, 4);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x23 = XVECEXP (x7, 0, 5);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x24 = XVECEXP (x7, 0, 6);
              if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
                return -1;
              x25 = XVECEXP (x7, 0, 7);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
                return -1;
              x26 = XVECEXP (x7, 0, 8);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x27 = XVECEXP (x7, 0, 9);
              if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x28 = XVECEXP (x7, 0, 10);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x29 = XVECEXP (x7, 0, 11);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x30 = XVECEXP (x7, 0, 12);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x31 = XVECEXP (x7, 0, 13);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x32 = XVECEXP (x7, 0, 14);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x33 = XVECEXP (x7, 0, 15);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1198 (x10, 
16) != 0)
                return -1;
              x34 = XVECEXP (x10, 0, 8);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x35 = XVECEXP (x10, 0, 9);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x36 = XVECEXP (x10, 0, 10);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x37 = XVECEXP (x10, 0, 11);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x38 = XVECEXP (x10, 0, 12);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x39 = XVECEXP (x10, 0, 13);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x40 = XVECEXP (x10, 0, 14);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x41 = XVECEXP (x10, 0, 15);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1706 (x14, 
16) != 0)
                return -1;
              x42 = XVECEXP (x14, 0, 8);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x43 = XVECEXP (x14, 0, 9);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x44 = XVECEXP (x14, 0, 10);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x45 = XVECEXP (x14, 0, 11);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x46 = XVECEXP (x14, 0, 12);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x14, 0, 13);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x48 = XVECEXP (x14, 0, 14);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x49 = XVECEXP (x14, 0, 15);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1724 (x17, 
16) != 0)
                return -1;
              x50 = XVECEXP (x17, 0, 8);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x51 = XVECEXP (x17, 0, 9);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x52 = XVECEXP (x17, 0, 10);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x53 = XVECEXP (x17, 0, 11);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x54 = XVECEXP (x17, 0, 12);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x55 = XVECEXP (x17, 0, 13);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x56 = XVECEXP (x17, 0, 14);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x57 = XVECEXP (x17, 0, 15);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1729 (x3, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0
                  || GET_MODE (x8) != E_V16HImode
                  || GET_MODE (x9) != E_V16QImode
                  || !nonimmediate_operand (operands[2], E_V32QImode)
                  || pattern293 (x11, 
E_V16QImode, 
E_V16HImode) != 0
                  || !
#line 22767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 7899; /* avx2_pmaddubsw256 */

            case 8:
              if (pattern1199 (x4) != 0
                  || pattern1706 (x14, 
8) != 0
                  || pattern1724 (x17, 
8) != 0
                  || pattern1729 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0
                  || GET_MODE (x8) != E_V8HImode
                  || GET_MODE (x9) != E_V8QImode
                  || !vector_operand (operands[2], E_V16QImode)
                  || pattern293 (x11, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 22854 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 7908; /* ssse3_pmaddubsw128 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern291 (x3))
            {
            case 0:
              if (!
#line 26096 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8280; /* xop_pmacssww */

            case 1:
              if (!
#line 26096 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8282; /* xop_pmacssdd */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern289 (x4) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 2:
              if (pattern1200 (x3) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V2DImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_MODE (x9) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              switch (pattern1670 (x4))
                {
                case 0:
                  if (!
#line 26115 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8284; /* xop_pmacssdql */

                case 1:
                  if (!
#line 26134 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8286; /* xop_pmacssdqh */

                default:
                  return -1;
                }

            case 4:
              if (pattern974 (x7, 
7, 
5, 
3, 
1) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              x9 = XEXP (x8, 0);
              x10 = XEXP (x9, 1);
              if (pattern1471 (x10, 
7, 
5, 
3, 
1) != 0
                  || !register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x5) != E_V4SImode
                  || GET_MODE (x6) != E_V4HImode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || GET_MODE (x8) != E_V4SImode
                  || GET_MODE (x9) != E_V4HImode
                  || !nonimmediate_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V4SImode)
                  || !
#line 26156 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8288; /* xop_pmacsswd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern292 (x5) != 0)
        return -1;
      x58 = XEXP (x5, 1);
      if (GET_MODE (x58) != E_V4SImode)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != VEC_SELECT
          || GET_MODE (x59) != E_V4HImode)
        return -1;
      x60 = XEXP (x59, 1);
      if (GET_CODE (x60) != PARALLEL
          || XVECLEN (x60, 0) != 4)
        return -1;
      x61 = XVECEXP (x60, 0, 0);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x62 = XVECEXP (x60, 0, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x63 = XVECEXP (x60, 0, 2);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x64 = XVECEXP (x60, 0, 3);
      if (x64 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_V4SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x19 = XEXP (x9, 0);
      if (GET_CODE (x19) != VEC_SELECT
          || GET_MODE (x19) != E_V4HImode)
        return -1;
      x65 = XEXP (x19, 1);
      if (GET_CODE (x65) != PARALLEL
          || XVECLEN (x65, 0) != 4)
        return -1;
      x66 = XVECEXP (x65, 0, 0);
      if (x66 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x67 = XVECEXP (x65, 0, 1);
      if (x67 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x68 = XVECEXP (x65, 0, 2);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x69 = XVECEXP (x65, 0, 3);
      if (x69 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x70 = XEXP (x8, 1);
      if (GET_CODE (x70) != SIGN_EXTEND
          || GET_MODE (x70) != E_V4SImode)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != VEC_SELECT
          || GET_MODE (x71) != E_V4HImode)
        return -1;
      x72 = XEXP (x71, 1);
      if (GET_CODE (x72) != PARALLEL
          || XVECLEN (x72, 0) != 4)
        return -1;
      x73 = XVECEXP (x72, 0, 0);
      if (x73 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x74 = XVECEXP (x72, 0, 1);
      if (x74 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x75 = XVECEXP (x72, 0, 2);
      if (x75 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x76 = XVECEXP (x72, 0, 3);
      if (x76 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || pattern1726 (x3) != 0
          || !
#line 26189 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8290; /* xop_pmadcsswd */

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17080 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6956; /* *ashrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 743 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 6966; /* ashrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8860; /* avx512vl_ashrvv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17080 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6958; /* *ashrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 6967; /* ashrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8858; /* avx512vl_ashrvv8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 6960; /* *ashrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 6968; /* ashrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8848; /* avx2_ashrvv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 6962; /* *ashrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 6969; /* ashrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8846; /* avx2_ashrvv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 6964; /* *ashrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 26970 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()))
        return 8346; /* *ashrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8852; /* avx2_ashrvv2di */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 788 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 6974; /* *ashrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8862; /* avx512bw_ashrvv32hi */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6976; /* *ashrv4di3 */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8854; /* avx2_ashrvv4di */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 6978; /* *ashrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8850; /* avx512f_ashrvv16si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 6980; /* *ashrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28892 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8856; /* avx512f_ashrvv8di */

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern173 (x3, 
E_V32HFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2264; /* *mulv32hf3 */

        case E_V16HFmode:
          if (pattern173 (x3, 
E_V16HFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2268; /* *mulv16hf3 */

        case E_V8HFmode:
          if (pattern173 (x3, 
E_V8HFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2272; /* *mulv8hf3 */

        case E_V16SFmode:
          if (pattern173 (x3, 
E_V16SFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2276; /* *mulv16sf3 */

        case E_V8SFmode:
          if (pattern173 (x3, 
E_V8SFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2280; /* *mulv8sf3 */

        case E_V4SFmode:
          if (pattern173 (x3, 
E_V4SFmode) != 0
              || !
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2284; /* *mulv4sf3 */

        case E_V8DFmode:
          if (pattern173 (x3, 
E_V8DFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2288; /* *mulv8df3 */

        case E_V4DFmode:
          if (pattern173 (x3, 
E_V4DFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2292; /* *mulv4df3 */

        case E_V2DFmode:
          if (pattern173 (x3, 
E_V2DFmode) != 0
              || !(
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2296; /* *mulv2df3 */

        case E_V32HImode:
          if (pattern26 (x3, 
E_V32HImode) != 0
              || !(
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6906; /* *mulv32hi3 */

        case E_V16HImode:
          if (pattern26 (x3, 
E_V16HImode) != 0
              || !(
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6908; /* *mulv16hi3 */

        case E_V8HImode:
          if (pattern26 (x3, 
E_V8HImode) != 0
              || !
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
            return -1;
          return 6910; /* *mulv8hi3 */

        case E_V8DImode:
          if (pattern173 (x3, 
E_V8DImode) != 0
              || !(
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 6944; /* *avx512dq_mulv8di3 */

        case E_V4DImode:
          if (pattern173 (x3, 
E_V4DImode) != 0
              || !(
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6946; /* *avx512dq_mulv4di3 */

        case E_V2DImode:
          if (pattern173 (x3, 
E_V2DImode) != 0
              || !(
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6948; /* *avx512dq_mulv2di3 */

        case E_V16SImode:
          if (pattern173 (x3, 
E_V16SImode) != 0
              || !(
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && 1) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6950; /* *avx512f_mulv16si3 */

        case E_V8SImode:
          if (pattern173 (x3, 
E_V8SImode) != 0
              || !(
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && 1) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6952; /* *avx2_mulv8si3 */

        case E_V4SImode:
          if (pattern173 (x3, 
E_V4SImode) != 0
              || !
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && 1))
            return -1;
          return 6954; /* *sse4_1_mulv4si3 */

        case E_V32BFmode:
          if (pattern27 (x3, 
E_V32BFmode) != 0
              || !
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9893; /* avx10_2_mulbf16_v32bf */

        case E_V16BFmode:
          if (pattern27 (x3, 
E_V16BFmode) != 0
              || !
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9901; /* avx10_2_mulbf16_v16bf */

        case E_V8BFmode:
          if (pattern27 (x3, 
E_V8BFmode) != 0
              || !
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9909; /* avx10_2_mulbf16_v8bf */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern185 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 16454 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6924; /* *vec_widen_umult_even_v16si */

        case 1:
          if (!
#line 16490 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6926; /* *vec_widen_umult_even_v8si */

        case 2:
          if (!
#line 16522 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6928; /* *vec_widen_umult_even_v4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern185 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 16570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6930; /* *vec_widen_smult_even_v16si */

        case 1:
          if (!
#line 16606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6932; /* *vec_widen_smult_even_v8si */

        case 2:
          if (!
#line 16638 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6934; /* *sse4_1_mulv2siv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2461; /* *smaxv32hf3 */

    case 1:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2469; /* *smaxv16hf3 */

    case 2:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2473; /* *smaxv8hf3 */

    case 3:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2477; /* *smaxv16sf3 */

    case 4:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2485; /* *smaxv8sf3 */

    case 5:
      if (!
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 2489; /* *smaxv4sf3 */

    case 6:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2493; /* *smaxv8df3 */

    case 7:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2501; /* *smaxv4df3 */

    case 8:
      if (!(
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2505; /* *smaxv2df3 */

    case 9:
      if (
#line 17653 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7101; /* *avx2_smaxv32qi3 */
      if (!(
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7177; /* *avx512bw_smaxv32qi3 */

    case 10:
      if (
#line 17653 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7105; /* *avx2_smaxv16hi3 */
      if (!(
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7193; /* *avx512bw_smaxv16hi3 */

    case 11:
      if (
#line 17653 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7109; /* *avx2_smaxv8si3 */
      if (!(
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7121; /* *avx512f_smaxv8si3 */

    case 12:
      if (!(
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7113; /* *avx512f_smaxv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7129; /* *avx512f_smaxv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17797 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7213; /* *sse4_1_smaxv4si3 */

    case 14:
      if (!(
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7137; /* *avx512f_smaxv8di3 */

    case 15:
      if (!(
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7145; /* *avx512f_smaxv4di3 */

    case 16:
      if (!(
#line 17694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7153; /* *avx512f_smaxv2di3 */

    case 17:
      if (!(
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7161; /* *avx512bw_smaxv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7169; /* *avx512bw_smaxv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17797 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7209; /* *sse4_1_smaxv16qi3 */

    case 19:
      if (!(
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7185; /* *avx512bw_smaxv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7201; /* *avx512bw_smaxv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17816 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7217; /* *smaxv8hi3 */

    case 21:
      if (!
#line 32108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9877; /* avx10_2_smaxbf16_v32bf */

    case 22:
      if (!
#line 32108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9881; /* avx10_2_smaxbf16_v16bf */

    case 23:
      if (!
#line 32108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9885; /* avx10_2_smaxbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern30 (x1))
    {
    case 0:
      if (!(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4011; /* avx512fp16_fix_truncv8hi2 */

    case 1:
      if (!(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4019; /* avx512fp16_fix_truncv16hi2 */

    case 2:
      if (!(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4027; /* avx512fp16_fix_truncv32hi2 */

    case 3:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4035; /* avx512fp16_fix_truncv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 8783 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4264; /* fix_truncv8sfv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4379; /* fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case 4:
      if (!(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4043; /* avx512fp16_fix_truncv16si2 */

    case 5:
      if (!
#line 8764 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 4254; /* fix_truncv16sfv16si2 */

    case 6:
      if (!(
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4051; /* avx512fp16_fix_truncv8di2 */

    case 7:
      if (!(
#line 9686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4416; /* fix_truncv8dfv8di2 */

    case 8:
      if (!(
#line 9729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4460; /* fix_truncv8sfv8di2 */

    case 9:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7919 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4075; /* *avx512fp16_fix_truncv4si2_load */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8813 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4268; /* fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4394; /* fix_truncv4dfv4si2 */

        default:
          return -1;
        }

    case 10:
      if (!
#line 7919 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4079; /* *avx512fp16_fix_truncv4di2_load */

    case 11:
      if (!(
#line 9686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4424; /* fix_truncv4dfv4di2 */

    case 12:
      if (!(
#line 9729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4468; /* fix_truncv4sfv4di2 */

    case 13:
      if (!
#line 7969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4091; /* *avx512fp16_fix_truncv2di2_load */

    case 14:
      if (!(
#line 9686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4428; /* fix_truncv2dfv2di2 */

    case 15:
      if (!
#line 7909 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4067; /* avx512fp16_fix_truncv4si2 */

    case 16:
      if (!
#line 7909 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4071; /* avx512fp16_fix_truncv4di2 */

    case 17:
      if (!
#line 7959 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4087; /* avx512fp16_fix_truncv2di2 */

    case 18:
      if (!
#line 9752 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4476; /* avx512dq_fix_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode)
          || !
#line 23726 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1368; /* sqrtxf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 23787 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 1371; /* sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_SFmode)
          || !
#line 23800 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
        return -1;
      return 1372; /* *sqrtsf2_sse */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimmediate_operand (operands[1], E_DFmode)
          || !
#line 23800 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
        return -1;
      return 1373; /* *sqrtdf2_sse */

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (XWINT (x4, 0) != 1LL)
        return -1;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 110; /* *extvsi_1_0 */

        case LTU:
        case UNLT:
          if (pattern504 (operands[1]) != 0)
            return -1;
          return 1448; /* *x86_movsicc_0_m1_se */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x3, 1);
      if (XWINT (x4, 0) == 1LL)
        {
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) == SUBREG)
            {
              switch (pattern1202 (x2))
                {
                case 0:
                  if (
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return 1181; /* *btsi_setcqi */
                  break;

                case 1:
                  if ((
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1182; /* *btdi_setcqi */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x3, 2);
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1204 (x2))
                {
                case 0:
                  if (
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                    return 1189; /* *btsi_setcsi_mask */
                  break;

                case 1:
                  if ((
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1190; /* *btdi_setcdi_mask */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      if (!const_0_to_255_operand (operands[3], E_QImode)
          || !
#line 22172 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
        return -1;
      return 1296; /* tbm_bextri_si */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern496 (x1))
    {
    case 0:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2815; /* *avx512f_cmpv16si3_zero_extendhi_2 */

    case 1:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2836; /* *avx512vl_cmpv16hf3_zero_extendhi_2 */

    case 2:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2842; /* *avx512f_cmpv16sf3_zero_extendhi_2 */

    case 3:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2908; /* *avx512vl_cmpv16qi3_zero_extendhi_2 */

    case 4:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2917; /* *avx512vl_cmpv16hi3_zero_extendhi_2 */

    case 5:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2818; /* *avx512vl_cmpv8si3_zero_extendhi_2 */

    case 6:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2821; /* *avx512vl_cmpv4si3_zero_extendhi_2 */

    case 7:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2824; /* *avx512f_cmpv8di3_zero_extendhi_2 */

    case 8:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2827; /* *avx512vl_cmpv4di3_zero_extendhi_2 */

    case 9:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2830; /* *avx512vl_cmpv2di3_zero_extendhi_2 */

    case 10:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2839; /* *avx512fp16_cmpv8hf3_zero_extendhi_2 */

    case 11:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2845; /* *avx512vl_cmpv8sf3_zero_extendhi_2 */

    case 12:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2848; /* *avx512vl_cmpv4sf3_zero_extendhi_2 */

    case 13:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2851; /* *avx512f_cmpv8df3_zero_extendhi_2 */

    case 14:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2854; /* *avx512vl_cmpv4df3_zero_extendhi_2 */

    case 15:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2857; /* *avx512vl_cmpv2df3_zero_extendhi_2 */

    case 16:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2920; /* *avx512vl_cmpv8hi3_zero_extendhi_2 */

    case 17:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2833; /* *avx512bw_cmpv32hf3_zero_extendhi_2 */

    case 18:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2911; /* *avx512vl_cmpv32qi3_zero_extendhi_2 */

    case 19:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2914; /* *avx512bw_cmpv32hi3_zero_extendhi_2 */

    case 20:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2905; /* *avx512bw_cmpv64qi3_zero_extendhi_2 */

    case 21:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2816; /* *avx512f_cmpv16si3_zero_extendsi_2 */

    case 22:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2837; /* *avx512vl_cmpv16hf3_zero_extendsi_2 */

    case 23:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2843; /* *avx512f_cmpv16sf3_zero_extendsi_2 */

    case 24:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2909; /* *avx512vl_cmpv16qi3_zero_extendsi_2 */

    case 25:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2918; /* *avx512vl_cmpv16hi3_zero_extendsi_2 */

    case 26:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2819; /* *avx512vl_cmpv8si3_zero_extendsi_2 */

    case 27:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2822; /* *avx512vl_cmpv4si3_zero_extendsi_2 */

    case 28:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2825; /* *avx512f_cmpv8di3_zero_extendsi_2 */

    case 29:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2828; /* *avx512vl_cmpv4di3_zero_extendsi_2 */

    case 30:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2831; /* *avx512vl_cmpv2di3_zero_extendsi_2 */

    case 31:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2840; /* *avx512fp16_cmpv8hf3_zero_extendsi_2 */

    case 32:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2846; /* *avx512vl_cmpv8sf3_zero_extendsi_2 */

    case 33:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2849; /* *avx512vl_cmpv4sf3_zero_extendsi_2 */

    case 34:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2852; /* *avx512f_cmpv8df3_zero_extendsi_2 */

    case 35:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2855; /* *avx512vl_cmpv4df3_zero_extendsi_2 */

    case 36:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2858; /* *avx512vl_cmpv2df3_zero_extendsi_2 */

    case 37:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2921; /* *avx512vl_cmpv8hi3_zero_extendsi_2 */

    case 38:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2834; /* *avx512bw_cmpv32hf3_zero_extendsi_2 */

    case 39:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2912; /* *avx512vl_cmpv32qi3_zero_extendsi_2 */

    case 40:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2915; /* *avx512bw_cmpv32hi3_zero_extendsi_2 */

    case 41:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2906; /* *avx512bw_cmpv64qi3_zero_extendsi_2 */

    case 42:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2817; /* *avx512f_cmpv16si3_zero_extenddi_2 */

    case 43:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2838; /* *avx512vl_cmpv16hf3_zero_extenddi_2 */

    case 44:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2844; /* *avx512f_cmpv16sf3_zero_extenddi_2 */

    case 45:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2910; /* *avx512vl_cmpv16qi3_zero_extenddi_2 */

    case 46:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2919; /* *avx512vl_cmpv16hi3_zero_extenddi_2 */

    case 47:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2820; /* *avx512vl_cmpv8si3_zero_extenddi_2 */

    case 48:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2823; /* *avx512vl_cmpv4si3_zero_extenddi_2 */

    case 49:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2826; /* *avx512f_cmpv8di3_zero_extenddi_2 */

    case 50:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2829; /* *avx512vl_cmpv4di3_zero_extenddi_2 */

    case 51:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2832; /* *avx512vl_cmpv2di3_zero_extenddi_2 */

    case 52:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2841; /* *avx512fp16_cmpv8hf3_zero_extenddi_2 */

    case 53:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2847; /* *avx512vl_cmpv8sf3_zero_extenddi_2 */

    case 54:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2850; /* *avx512vl_cmpv4sf3_zero_extenddi_2 */

    case 55:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2853; /* *avx512f_cmpv8df3_zero_extenddi_2 */

    case 56:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2856; /* *avx512vl_cmpv4df3_zero_extenddi_2 */

    case 57:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2859; /* *avx512vl_cmpv2df3_zero_extenddi_2 */

    case 58:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2922; /* *avx512vl_cmpv8hi3_zero_extenddi_2 */

    case 59:
      if (!(
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2835; /* *avx512bw_cmpv32hf3_zero_extenddi_2 */

    case 60:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2913; /* *avx512vl_cmpv32qi3_zero_extenddi_2 */

    case 61:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2916; /* *avx512bw_cmpv32hi3_zero_extenddi_2 */

    case 62:
      if (!(
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2907; /* *avx512bw_cmpv64qi3_zero_extenddi_2 */

    case 63:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2989; /* *avx512bw_ucmpv64qi3_zero_extendhi_2 */

    case 64:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2992; /* *avx512vl_ucmpv16qi3_zero_extendhi_2 */

    case 65:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3001; /* *avx512vl_ucmpv16hi3_zero_extendhi_2 */

    case 66:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3061; /* *avx512f_ucmpv16si3_zero_extendhi_2 */

    case 67:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2995; /* *avx512vl_ucmpv32qi3_zero_extendhi_2 */

    case 68:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2998; /* *avx512bw_ucmpv32hi3_zero_extendhi_2 */

    case 69:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3004; /* *avx512vl_ucmpv8hi3_zero_extendhi_2 */

    case 70:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3062; /* *avx512vl_ucmpv8si3_zero_extendhi_2 */

    case 71:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3063; /* *avx512vl_ucmpv4si3_zero_extendhi_2 */

    case 72:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3064; /* *avx512f_ucmpv8di3_zero_extendhi_2 */

    case 73:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3065; /* *avx512vl_ucmpv4di3_zero_extendhi_2 */

    case 74:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3066; /* *avx512vl_ucmpv2di3_zero_extendhi_2 */

    case 75:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2990; /* *avx512bw_ucmpv64qi3_zero_extendsi_2 */

    case 76:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2993; /* *avx512vl_ucmpv16qi3_zero_extendsi_2 */

    case 77:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3002; /* *avx512vl_ucmpv16hi3_zero_extendsi_2 */

    case 78:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3067; /* *avx512f_ucmpv16si3_zero_extendsi_2 */

    case 79:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2996; /* *avx512vl_ucmpv32qi3_zero_extendsi_2 */

    case 80:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2999; /* *avx512bw_ucmpv32hi3_zero_extendsi_2 */

    case 81:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3005; /* *avx512vl_ucmpv8hi3_zero_extendsi_2 */

    case 82:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3068; /* *avx512vl_ucmpv8si3_zero_extendsi_2 */

    case 83:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3069; /* *avx512vl_ucmpv4si3_zero_extendsi_2 */

    case 84:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3070; /* *avx512f_ucmpv8di3_zero_extendsi_2 */

    case 85:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3071; /* *avx512vl_ucmpv4di3_zero_extendsi_2 */

    case 86:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3072; /* *avx512vl_ucmpv2di3_zero_extendsi_2 */

    case 87:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2991; /* *avx512bw_ucmpv64qi3_zero_extenddi_2 */

    case 88:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2994; /* *avx512vl_ucmpv16qi3_zero_extenddi_2 */

    case 89:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3003; /* *avx512vl_ucmpv16hi3_zero_extenddi_2 */

    case 90:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3073; /* *avx512f_ucmpv16si3_zero_extenddi_2 */

    case 91:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2997; /* *avx512vl_ucmpv32qi3_zero_extenddi_2 */

    case 92:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3000; /* *avx512bw_ucmpv32hi3_zero_extenddi_2 */

    case 93:
      if (!(
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3006; /* *avx512vl_ucmpv8hi3_zero_extenddi_2 */

    case 94:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3074; /* *avx512vl_ucmpv8si3_zero_extenddi_2 */

    case 95:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3075; /* *avx512vl_ucmpv4si3_zero_extenddi_2 */

    case 96:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3076; /* *avx512f_ucmpv8di3_zero_extenddi_2 */

    case 97:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3077; /* *avx512vl_ucmpv4di3_zero_extenddi_2 */

    case 98:
      if (!(
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3078; /* *avx512vl_ucmpv2di3_zero_extenddi_2 */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern752 (x8))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern1211 (x4, 
E_HImode) != 0
                  || !
#line 13609 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 678; /* *notxorhi_1 */

            case E_SImode:
              if (pattern1212 (x4, 
E_SImode) != 0
                  || !
#line 13609 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 679; /* *notxorsi_1 */

            case E_DImode:
              if (pattern1212 (x4, 
E_DImode) != 0
                  || !(
#line 13609 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 680; /* *notxordi_1 */

            case E_QImode:
              if (pattern1211 (x4, 
E_QImode) != 0
                  || !
#line 13809 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 708; /* *notxorqi_1 */

            default:
              return -1;
            }

        case 1:
          if (pattern1213 (x4, 
E_QImode) != 0
              || !
#line 2181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2076; /* kxnorqi */

        case 2:
          if (pattern1213 (x4, 
E_HImode) != 0
              || !
#line 2181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2077; /* kxnorhi */

        case 3:
          if (pattern1213 (x4, 
E_SImode) != 0
              || !(
#line 2181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2078; /* kxnorsi */

        case 4:
          if (pattern1213 (x4, 
E_DImode) != 0
              || !(
#line 2181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2079; /* kxnordi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (pattern629 (x1))
        {
        case 0:
          if (!
#line 2202 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2080; /* knotqi */

        case 1:
          if (!
#line 2202 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2081; /* knothi */

        case 2:
          if (!(
#line 2202 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2082; /* knotsi */

        case 3:
          if (!(
#line 2202 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2083; /* knotdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern192 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern635 (x1))
        {
        case 0:
          if ((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 913; /* *lshrdi3_doubleword_mask */
          break;

        case 1:
          if ((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 915; /* *lshrti3_doubleword_mask */
          break;

        case 2:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return 2090; /* klshiftrtqi */
          break;

        case 3:
          if (
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2092; /* klshiftrthi */
          break;

        case 4:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2094; /* klshiftrtsi */
          break;

        case 5:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2096; /* klshiftrtdi */
          break;

        default:
          break;
        }
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern636 (x1))
        {
        case 0:
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x4) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && register_operand (operands[1], E_DImode))
                    return 921; /* lshrdi3_doubleword */
                  if (nonimmediate_operand (operands[0], E_DImode)
                      && nonimmediate_operand (operands[1], E_DImode)
                      && (
#line 17387 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 956; /* *lshrdi3_1 */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 17387 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
                return 954; /* *lshrsi3_1 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && GET_MODE (x4) == E_QImode
                  && nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 17563 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return 982; /* *lshrqi3_1 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 17601 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return 984; /* *lshrhi3_1 */
              break;

            case E_V2QImode:
              if (register_operand (operands[0], E_V2QImode)
                  && GET_MODE (x4) == E_V2QImode
                  && register_operand (operands[1], E_V2QImode)
                  && 
#line 4007 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return 1748; /* lshrv2qi3 */
              break;

            default:
              break;
            }
          break;

        case 1:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          switch (pattern323 (x4))
            {
            case 0:
              if (
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 985; /* *lshrqi3_1_slp */
              break;

            case 1:
              if (
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 987; /* *lshrhi3_1_slp */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern639 (x1))
        {
        case 0:
          if (!
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          return 1010; /* *lshrsi3_mask */

        case 1:
          if (!(
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1013; /* *lshrdi3_mask */

        case 2:
          if (!
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1022; /* *lshrsi3_add */

        case 3:
          if (!(
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1025; /* *lshrdi3_add */

        case 4:
          if (!
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1034; /* *lshrsi3_sub */

        case 5:
          if (!(
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1037; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 917; /* *lshrdi3_doubleword_mask_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1019; /* *lshrdi3_mask_1 */

    case 2:
      if (!(
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 919; /* *lshrti3_doubleword_mask_1 */

    case 3:
      if (!
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      return 1016; /* *lshrsi3_mask_1 */

    case 4:
      if (!
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1028; /* *lshrsi3_add_1 */

    case 5:
      if (!(
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1031; /* *lshrdi3_add_1 */

    case 6:
      if (!
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1040; /* *lshrsi3_sub_1 */

    case 7:
      if (!(
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1043; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 153)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != 154)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SCRATCH)
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 4)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x13 = XVECEXP (x9, 0, 3);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XVECEXP (x6, 0, 1);
  if (!register_operand (x16, E_V4DImode))
    return -1;
  x17 = XVECEXP (x6, 0, 2);
  if (!const1248_operand (x17, E_SImode))
    return -1;
  x18 = XEXP (x14, 0);
  operands[1] = x18;
  x19 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x19))
    {
    case REG:
    case SUBREG:
      operands[2] = x19;
      operands[7] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[3] = x20;
      operands[4] = x16;
      operands[6] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[5] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1695 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9027; /* *avx2_gatherdiv8si_3 */

            case 1:
              if (!(
#line 29394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9029; /* *avx2_gatherdiv8si_3 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1695 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9028; /* *avx2_gatherdiv8sf_3 */

            case 1:
              if (!(
#line 29394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9030; /* *avx2_gatherdiv8sf_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PC:
      operands[6] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[2] = x20;
      operands[3] = x16;
      operands[5] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[4] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1691 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9031; /* *avx2_gatherdiv8si_4 */

            case 1:
              if (!(
#line 29418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9033; /* *avx2_gatherdiv8si_4 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1691 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9032; /* *avx2_gatherdiv8sf_4 */

            case 1:
              if (!(
#line 29418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9034; /* *avx2_gatherdiv8sf_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_398 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case UNSIGNED_FIX:
      switch (pattern519 (x1))
        {
        case 0:
          if (!
#line 5911 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
            return -1;
          return 177; /* *fixuns_truncsf_1 */

        case 1:
          if (!
#line 5911 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
            return -1;
          return 178; /* *fixuns_truncdf_1 */

        default:
          return -1;
        }

    case FIX:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != USE
          || !nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_HImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[3] = x10;
      if (!memory_operand (operands[3], E_HImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[4] = x11;
      if (!scratch_operand (operands[4], E_XFmode)
          || !
#line 6021 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(TARGET_64BIT && SSE_FLOAT_MODE_P (GET_MODE (operands[1])))))
        return -1;
      return 187; /* fix_truncdi_i387 */

    case FLOAT:
      switch (pattern521 (x1))
        {
        case 0:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          return 202; /* floatdisf2_i387_with_xmm */

        case 1:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          return 203; /* floatdidf2_i387_with_xmm */

        case 2:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          return 204; /* floatdixf2_i387_with_xmm */

        default:
          return -1;
        }

    case DIV:
      switch (pattern526 (x1, 
MOD))
        {
        case 0:
          return 529; /* divmodsi4_1 */

        case 1:
          if (!
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
            return -1;
          return 541; /* *divmodhi4_noext */

        case 2:
          return 543; /* *divmodsi4_noext */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern526 (x1, 
UMOD))
        {
        case 0:
          return 530; /* udivmodsi4_1 */

        case 1:
          if (!
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
            return -1;
          return 542; /* *udivmodhi4_noext */

        case 2:
          return 544; /* *udivmodsi4_noext */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 4:
          if (XINT (x5, 1) != 20
              || pattern747 (x5) != 0
              || pattern1123 (x1) != 0
              || !tls_symbolic_operand (operands[2], E_VOIDmode))
            return -1;
          x12 = XVECEXP (x5, 0, 2);
          operands[3] = x12;
          if (!constant_call_address_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x7, 0);
          operands[5] = x10;
          if (!scratch_operand (operands[5], E_SImode)
              || !
#line 22953 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU_TLS))
            return -1;
          return 1321; /* *tls_global_dynamic_32_gnu */

        case 3:
          if (XINT (x5, 1) != 21
              || GET_MODE (x5) != E_SImode)
            return -1;
          x12 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 7
              || GET_MODE (x12) != E_SImode
              || pattern1123 (x1) != 0
              || !constant_call_address_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x7, 0);
          operands[4] = x10;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 23073 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU_TLS))
            return -1;
          return 1322; /* *tls_local_dynamic_base_32_gnu */

        case 1:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != USE
              || !nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x5) != E_DImode)
            return -1;
          x13 = XVECEXP (x5, 0, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!memory_operand (operands[2], E_HImode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[3] = x10;
          if (!memory_operand (operands[3], E_HImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[4] = x11;
          if (!scratch_operand (operands[4], E_XFmode))
            return -1;
          switch (XINT (x5, 1))
            {
            case 78:
              if (!
#line 25376 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1410; /* fistdi2_floor */

            case 79:
              if (!
#line 25376 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1411; /* fistdi2_ceil */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern527 (x1) != 0)
        return -1;
      return 1323; /* *tls_local_dynamic_32_once */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 3)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x14 = XEXP (x6, 1);
      if (GET_CODE (x14) != MINUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 7)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 7)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (pattern864 (x7, 
E_CCmode, 
17) != 0)
        return -1;
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != MEM
          || GET_MODE (x11) != E_BLKmode)
        return -1;
      x16 = XEXP (x11, 0);
      if (GET_CODE (x16) != SCRATCH)
        return -1;
      x13 = XVECEXP (x5, 0, 0);
      operands[1] = x13;
      x17 = XEXP (x14, 1);
      operands[2] = x17;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1621 (x1, 
E_SImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
            return -1;
          return 1509; /* adjust_stack_and_probe_si */

        case E_DImode:
          if (pattern1621 (x1, 
E_DImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
            return -1;
          return 1510; /* adjust_stack_and_probe_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LTU:
      if (GET_MODE (x2) != E_CCCmode)
        return NULL;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return NULL;
      switch (pattern558 (x1))
        {
        case 0:
          if (!(
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 1:
          if (!(
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_163 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern343 (x1))
        {
        case 0:
          return gen_split_716 (insn, operands);

        case 1:
          return gen_split_717 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern343 (x1))
        {
        case 0:
          return gen_split_718 (insn, operands);

        case 1:
          return gen_split_719 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 2);
  operands[2] = x9;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x2, 1);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern1380 (x2, 
E_HImode))
        {
        case 0:
          if (!
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_692 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_693 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern1380 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_694 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_695 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern1380 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_697 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pattern335 (x3) != 0
          || !(
#line 3748 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_12 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern757 (x3, 
E_QImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_101 (insn, operands);

        case E_HImode:
          if (pattern757 (x3, 
E_HImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_102 (insn, operands);

        case E_SImode:
          if (pattern758 (x3, 
E_SImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_103 (insn, operands);

        case E_DImode:
          if (pattern758 (x3, 
E_DImode) != 0
              || !(
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern369 (x3))
            {
            case 0:
              if (!(
#line 7898 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_120 (insn, operands);

            case 1:
              if (!(
#line 7898 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_121 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          switch (pattern372 (x3))
            {
            case 0:
              if (!(
#line 7964 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 1:
              if (!(
#line 7964 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_127 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern373 (x3))
            {
            case 0:
              if (!(
#line 7990 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 1:
              if (!(
#line 7990 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_129 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern337 (x3))
        {
        case 0:
          if (!(
#line 7920 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_122 (insn, operands);

        case 1:
          if (!(
#line 7920 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_123 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern340 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern881 (x3, 
E_QImode) != 0
                      || !(
#line 7941 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case E_HImode:
                  if (pattern881 (x3, 
E_HImode) != 0
                      || !(
#line 7941 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case E_DImode:
                  if (pattern776 (x3, 
E_DImode) != 0
                      || !((
#line 14139 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_371 (insn, operands);

                case E_TImode:
                  if (pattern776 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_374 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (pattern693 (x3) != 0
                  || !((
#line 14062 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!((
#line 14098 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_359 (insn, operands);

        case 2:
          if (!((
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_377 (insn, operands);

        case 3:
          if (!((
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_383 (insn, operands);

        case 4:
          if (!((
#line 14098 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_362 (insn, operands);

        case 5:
          if (!((
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_380 (insn, operands);

        case 6:
          if (!((
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_386 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern342 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_356 (insn, operands);

        case 1:
          if (!((
#line 14123 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_365 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_368 (insn, operands);

        case 3:
          if (!((
#line 14200 "../../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_389 (insn, operands);

        case 4:
          if (!((
#line 14200 "../../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_392 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern300 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (pattern193 (x3))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (GET_CODE (x7) == SUBREG)
                {
                  switch (pattern1214 (x4))
                    {
                    case 0:
                      if (((
#line 15205 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15210 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_457 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 15205 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 15210 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_458 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x7;
              if (register_operand (operands[2], E_QImode)
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 15990 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return gen_split_469 (insn, operands);
              if (GET_CODE (x7) == SUBREG
                  && known_eq (SUBREG_BYTE (x7), 0)
                  && GET_MODE (x7) == E_QImode)
                {
                  switch (pattern1129 (x4, 
E_SImode))
                    {
                    case 0:
                      if ((
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17847 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_515 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17894 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_527 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17940 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_539 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case CONST_INT:
              operands[2] = x7;
              if (const_0_to_3_operand (operands[2], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (general_reg_operand (operands[0], E_QImode)
                          && GET_MODE (x4) == E_QImode
                          && index_reg_operand (operands[1], E_QImode)
                          && 
#line 16285 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_472 (insn, operands);
                      break;

                    case E_HImode:
                      if (general_reg_operand (operands[0], E_HImode)
                          && GET_MODE (x4) == E_HImode
                          && index_reg_operand (operands[1], E_HImode)
                          && 
#line 16285 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_473 (insn, operands);
                      break;

                    case E_SImode:
                      if (general_reg_operand (operands[0], E_SImode)
                          && GET_MODE (x4) == E_SImode
                          && index_reg_operand (operands[1], E_SImode)
                          && 
#line 16285 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_474 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
          operands[2] = x7;
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[0] = x6;
              if (GET_MODE (x4) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && nonmemory_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_QImode)
                      && (
#line 15325 "../../../gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return gen_split_461 (insn, operands);
                  if (general_reg_operand (operands[0], E_DImode)
                      && index_reg_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && (
#line 16285 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_475 (insn, operands);
                }
              break;

            case STRICT_LOW_PART:
              switch (pattern1215 (x3))
                {
                case 0:
                  if ((
#line 16235 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16254 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                    return gen_split_470 (insn, operands);
                  break;

                case 1:
                  if ((
#line 16235 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16254 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                    return gen_split_471 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != SUBREG)
            return NULL;
          switch (pattern1130 (x3))
            {
            case 0:
              if (!((
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17847 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_518 (insn, operands);

            case 1:
              if (!((
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17894 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_530 (insn, operands);

            case 2:
              if (!((
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17940 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_542 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && ((
#line 15266 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15271 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_459 (insn, operands);
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !((
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17872 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_524 (insn, operands);

        case 2:
          if (!((
#line 15266 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 15271 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 3:
          if (!(
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17872 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_521 (insn, operands);

        case 4:
          if (!(
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17918 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_533 (insn, operands);

        case 5:
          if (!((
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17918 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_536 (insn, operands);

        case 6:
          if (!(
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17970 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_545 (insn, operands);

        case 7:
          if (!((
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17970 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_548 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || pattern327 (x3) != 0
          || !((
#line 15367 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15370 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_462 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || pattern327 (x3) != 0
          || !((
#line 15367 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15370 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_463 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern194 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) == SUBREG)
        {
          switch (pattern1214 (x4))
            {
            case 0:
              if (((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16589 "../../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_484 (insn, operands);
              break;

            case 1:
              if (((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16589 "../../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_486 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) == E_SImode
          && nonimmediate_operand (operands[1], E_SImode))
        {
          if (register_operand (operands[0], E_SImode))
            {
              operands[2] = x5;
              if (register_operand (operands[2], E_QImode)
                  && 
#line 17437 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return gen_split_504 (insn, operands);
            }
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1361 (x5))
                {
                case 0:
                  if ((
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17847 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_517 (insn, operands);
                  break;

                case 1:
                  if ((
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17894 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_529 (insn, operands);
                  break;

                case 2:
                  if ((
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17940 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_541 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x5;
      switch (pattern1127 (x2))
        {
        case 0:
          if ((
#line 16696 "../../../gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return gen_split_492 (insn, operands);
          break;

        case 1:
          if ((
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17651 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_506 (insn, operands);
          break;

        case 2:
          if ((
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17651 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_508 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return NULL;
      switch (pattern1130 (x2))
        {
        case 0:
          if (!((
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17847 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_520 (insn, operands);

        case 1:
          if (!((
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17894 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_532 (insn, operands);

        case 2:
          if (!((
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17940 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_544 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && ((
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16650 "../../../gcc/config/i386/i386.md"
( 1)))
        return gen_split_488 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !((
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17872 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_526 (insn, operands);

    case 2:
      if (!((
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16650 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_490 (insn, operands);

    case 3:
      if (!(
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17872 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_523 (insn, operands);

    case 4:
      if (!(
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17918 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_535 (insn, operands);

    case 5:
      if (!((
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17918 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_538 (insn, operands);

    case 6:
      if (!(
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17970 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_547 (insn, operands);

    case 7:
      if (!((
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17970 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_550 (insn, operands);

    case 8:
      if (!((
#line 17990 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 17993 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_551 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_39 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_VOIDmode)
          && general_reg_operand (operands[0], E_VOIDmode)
          && 
#line 27765 "../../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && (GET_MODE (operands[0]) == HImode
       || (GET_MODE (operands[0]) == QImode && TARGET_PROMOTE_QImode))))
        return gen_split_818 (insn, operands);
      if (general_reg_operand (operands[1], E_V4QImode)
          && general_reg_operand (operands[0], E_V4QImode)
          && GET_MODE (x3) == E_V4QImode
          && 
#line 4557 "../../../gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_863 (insn, operands);
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && GET_MODE (x3) == E_V2QImode
          && 
#line 4557 "../../../gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_864 (insn, operands);
      if (general_reg_operand (operands[1], E_V2HImode)
          && general_reg_operand (operands[0], E_V2HImode)
          && GET_MODE (x3) == E_V2HImode
          && 
#line 4557 "../../../gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_865 (insn, operands);
      if (sse_reg_operand (operands[1], E_V4QImode)
          && sse_reg_operand (operands[0], E_V4QImode)
          && GET_MODE (x3) == E_V4QImode
          && 
#line 4569 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_866 (insn, operands);
      if (sse_reg_operand (operands[1], E_V2QImode)
          && sse_reg_operand (operands[0], E_V2QImode)
          && GET_MODE (x3) == E_V2QImode
          && 
#line 4569 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_867 (insn, operands);
      if (sse_reg_operand (operands[1], E_V2HImode)
          && sse_reg_operand (operands[0], E_V2HImode)
          && GET_MODE (x3) == E_V2HImode
          && 
#line 4569 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_868 (insn, operands);
      if (mask_reg_operand (operands[1], E_QImode)
          && mask_reg_operand (operands[0], E_QImode)
          && GET_MODE (x3) == E_QImode
          && 
#line 2222 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
        return gen_split_999 (insn, operands);
      if (mask_reg_operand (operands[1], E_HImode)
          && mask_reg_operand (operands[0], E_HImode)
          && GET_MODE (x3) == E_HImode
          && 
#line 2222 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
        return gen_split_1000 (insn, operands);
      if (mask_reg_operand (operands[1], E_SImode)
          && mask_reg_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && (
#line 2222 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return gen_split_1001 (insn, operands);
      if (!mask_reg_operand (operands[1], E_DImode)
          || !mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !(
#line 2222 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return NULL;
      return gen_split_1002 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[3] = x7;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern879 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1168 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1175 (insn, operands);

                case 2:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1177 (insn, operands);

                case 3:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1203 (insn, operands);

                case 4:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1209 (insn, operands);

                default:
                  return NULL;
                }

            case E_QImode:
              switch (pattern880 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1169 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1170 (insn, operands);

                case 2:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1171 (insn, operands);

                case 3:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1172 (insn, operands);

                case 4:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1173 (insn, operands);

                case 5:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1176 (insn, operands);

                case 6:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1178 (insn, operands);

                case 7:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1179 (insn, operands);

                case 8:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1180 (insn, operands);

                case 9:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1181 (insn, operands);

                case 10:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1182 (insn, operands);

                case 11:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1211 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              switch (pattern890 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4474 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1174 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1205 (insn, operands);

                case 2:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1207 (insn, operands);

                default:
                  return NULL;
                }

            case E_DImode:
              if (pattern891 (x3) != 0
                  || !((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1201 (insn, operands);

            default:
              return NULL;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern985 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1202 (insn, operands);

            case E_HImode:
              switch (pattern971 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1204 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1210 (insn, operands);

                case 2:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1249 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              switch (pattern986 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1206 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1208 (insn, operands);

                default:
                  return NULL;
                }

            case E_QImode:
              switch (pattern972 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1212 (insn, operands);

                case 1:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1250 (insn, operands);

                case 2:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1251 (insn, operands);

                case 3:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1252 (insn, operands);

                case 4:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1253 (insn, operands);

                case 5:
                  if (!((
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1254 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_53 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern762 (x3) != 0)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode)
              || !(
#line 12527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1340 (insn, operands);

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 12928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1349 (insn, operands);

        default:
          return NULL;
        }

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !(
#line 12527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1341 (insn, operands);

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !
#line 12928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1348 (insn, operands);

        default:
          return NULL;
        }

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 12592 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || (REG_P (operands[0]) && !EXT_REX_SSE_REG_P (operands[1])))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1342 (insn, operands);

    case E_V4DImode:
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 12592 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || (REG_P (operands[0]) && !EXT_REX_SSE_REG_P (operands[1])))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1343 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      res = split_52 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 4:
      res = split_53 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 8:
      res = split_54 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 16:
      if (pattern763 (x3, 
6, 
5, 
4) == 0
          && pattern1363 (x3, 
11, 
10, 
9, 
8, 
7) == 0)
        {
          switch (pattern1623 (x2))
            {
            case 0:
              if (((
#line 13011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1350 (insn, operands);
              break;

            case 1:
              if (((
#line 13011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1351 (insn, operands);
              break;

            case 2:
              if (((
#line 13011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1352 (insn, operands);
              break;

            case 3:
              if ((
#line 13181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13183 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1357 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case 32:
      if (pattern765 (x3, 
11, 
10, 
9, 
8) == 0
          && pattern1536 (x3, 
15, 
14, 
13, 
12, 
16) == 0
          && pattern1642 (x3, 
21, 
20, 
19, 
18, 
17) == 0
          && pattern1687 (x3, 
26, 
25, 
24, 
23, 
22) == 0)
        {
          x4 = XVECEXP (x3, 0, 27);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 27]
              && pattern1704 (x3, 
31, 
30, 
29, 
28) == 0
              && nonimmediate_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && nonimmediate_operand (operands[1], E_V64QImode)
              && (
#line 13113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13123 "../../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
            return gen_split_1356 (insn, operands);
        }
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) < 1)
    return NULL;
  operands[2] = x3;
  if (!avx_vbroadcast_operand (operands[2], E_VOIDmode))
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !(
#line 27379 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27382 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3453 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !(
#line 27379 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27382 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3454 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern467 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1440 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1467 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1494 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1548 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1575 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1602 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1629 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1656 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1683 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1710 (insn, operands);

        case 11:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1737 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1443 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1470 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1497 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1551 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1578 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1605 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1632 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1659 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1686 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1713 (insn, operands);

        case 23:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1740 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1446 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1473 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1500 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1554 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1581 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1608 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1635 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1662 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1689 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1716 (insn, operands);

        case 35:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1743 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2736 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2745 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2754 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2763 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2772 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2781 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2790 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2808 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2817 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2826 (insn, operands);

        case 47:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2835 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2088 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2115 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2142 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2169 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2196 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2223 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2250 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2277 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2304 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2091 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2118 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2145 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2172 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2199 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2226 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2253 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2280 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2307 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2334 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2361 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2388 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern1069 (x2, 
E_V64QImode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2094 (insn, operands);

        case E_V32QImode:
          if (pattern903 (x2, 
E_V32QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V32QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V32QImode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2121 (insn, operands);
            }
          if (!register_operand (operands[1], E_V32QImode)
              || !register_operand (operands[2], E_V32QImode)
              || !nonimmediate_operand (operands[3], E_V32QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3420 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3436 (insn, operands);

        case E_V16QImode:
          if (pattern903 (x2, 
E_V16QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16QImode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2148 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !nonimmediate_operand (operands[3], E_V16QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3421 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3437 (insn, operands);

        case E_V32HImode:
          if (pattern1069 (x2, 
E_V32HImode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2175 (insn, operands);

        case E_V16HImode:
          if (pattern903 (x2, 
E_V16HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16HImode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2202 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16HImode)
              || !register_operand (operands[2], E_V16HImode)
              || !nonimmediate_operand (operands[3], E_V16HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3422 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3438 (insn, operands);

        case E_V8HImode:
          if (pattern903 (x2, 
E_V8HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8HImode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2229 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !nonimmediate_operand (operands[3], E_V8HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3423 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3439 (insn, operands);

        case E_V16SImode:
          if (pattern1069 (x2, 
E_V16SImode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2256 (insn, operands);

        case E_V8SImode:
          if (pattern903 (x2, 
E_V8SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8SImode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2283 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8SImode)
              || !register_operand (operands[2], E_V8SImode)
              || !nonimmediate_operand (operands[3], E_V8SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3424 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3440 (insn, operands);

        case E_V4SImode:
          if (pattern903 (x2, 
E_V4SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4SImode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2310 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !nonimmediate_operand (operands[3], E_V4SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3425 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3441 (insn, operands);

        case E_V8DImode:
          if (pattern1069 (x2, 
E_V8DImode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2337 (insn, operands);

        case E_V4DImode:
          if (pattern903 (x2, 
E_V4DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4DImode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2364 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4DImode)
              || !register_operand (operands[2], E_V4DImode)
              || !nonimmediate_operand (operands[3], E_V4DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3426 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3442 (insn, operands);

        case E_V2DImode:
          if (pattern903 (x2, 
E_V2DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V2DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V2DImode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2391 (insn, operands);
            }
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !nonimmediate_operand (operands[3], E_V2DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3427 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3443 (insn, operands);

        case E_V2TImode:
          if (pattern1070 (x2, 
E_V2TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3428 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3444 (insn, operands);

        case E_V1TImode:
          if (pattern1070 (x2, 
E_V1TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3429 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3445 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = split_58 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
      res = split_65 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          res = split_60 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          res = split_61 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case XOR:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
            case NOT:
              switch (pattern467 (x2))
                {
                case 0:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1458 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1485 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1512 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1539 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1566 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1593 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1620 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1647 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1674 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1701 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1728 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1755 (insn, operands);
                  break;

                case 12:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1461 (insn, operands);
                  break;

                case 13:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1488 (insn, operands);
                  break;

                case 14:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1515 (insn, operands);
                  break;

                case 15:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1542 (insn, operands);
                  break;

                case 16:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1569 (insn, operands);
                  break;

                case 17:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1596 (insn, operands);
                  break;

                case 18:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1623 (insn, operands);
                  break;

                case 19:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1650 (insn, operands);
                  break;

                case 20:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1677 (insn, operands);
                  break;

                case 21:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1704 (insn, operands);
                  break;

                case 22:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1731 (insn, operands);
                  break;

                case 23:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1758 (insn, operands);
                  break;

                case 24:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1464 (insn, operands);
                  break;

                case 25:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1491 (insn, operands);
                  break;

                case 26:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1518 (insn, operands);
                  break;

                case 27:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1545 (insn, operands);
                  break;

                case 28:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1572 (insn, operands);
                  break;

                case 29:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1599 (insn, operands);
                  break;

                case 30:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1626 (insn, operands);
                  break;

                case 31:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1653 (insn, operands);
                  break;

                case 32:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1680 (insn, operands);
                  break;

                case 33:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1707 (insn, operands);
                  break;

                case 34:
                  if (((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1734 (insn, operands);
                  break;

                case 35:
                  if ((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1761 (insn, operands);
                  break;

                case 36:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2742 (insn, operands);
                  break;

                case 37:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2751 (insn, operands);
                  break;

                case 38:
                  if ((
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2760 (insn, operands);
                  break;

                case 39:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2769 (insn, operands);
                  break;

                case 40:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2778 (insn, operands);
                  break;

                case 41:
                  if ((
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2787 (insn, operands);
                  break;

                case 42:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2796 (insn, operands);
                  break;

                case 43:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2805 (insn, operands);
                  break;

                case 44:
                  if ((
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2814 (insn, operands);
                  break;

                case 45:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2823 (insn, operands);
                  break;

                case 46:
                  if (((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2832 (insn, operands);
                  break;

                case 47:
                  if ((
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2841 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2133 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2160 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2187 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2214 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2241 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2268 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2295 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2322 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2349 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2376 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2403 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IOR:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2109 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2136 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2163 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2190 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2217 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2244 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2271 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2298 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2325 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2352 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2379 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2406 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2112 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2139 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2166 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2193 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2220 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2247 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2274 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2301 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2328 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2355 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2382 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2409 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern845 (x2, 
E_V16SImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3102 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern845 (x2, 
E_V8DImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3103 (insn, operands);
              break;

            case E_V64QImode:
              if (pattern845 (x2, 
E_V64QImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3104 (insn, operands);
              break;

            case E_V32QImode:
              if (pattern845 (x2, 
E_V32QImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3105 (insn, operands);
              break;

            case E_V16QImode:
              if (pattern845 (x2, 
E_V16QImode) == 0
                  && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3106 (insn, operands);
              break;

            case E_V32HImode:
              if (pattern845 (x2, 
E_V32HImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3107 (insn, operands);
              break;

            case E_V16HImode:
              if (pattern845 (x2, 
E_V16HImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3108 (insn, operands);
              break;

            case E_V8HImode:
              if (pattern845 (x2, 
E_V8HImode) == 0
                  && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3109 (insn, operands);
              break;

            case E_V8SImode:
              if (pattern845 (x2, 
E_V8SImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3110 (insn, operands);
              break;

            case E_V4SImode:
              if (pattern845 (x2, 
E_V4SImode) == 0
                  && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3111 (insn, operands);
              break;

            case E_V4DImode:
              if (pattern845 (x2, 
E_V4DImode) == 0
                  && ((
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3112 (insn, operands);
              break;

            case E_V2DImode:
              if (pattern845 (x2, 
E_V2DImode) == 0
                  && (
#line 18344 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 18355 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3113 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x3) == VEC_DUPLICATE)
            {
              switch (pattern543 (x2))
                {
                case 0:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3146 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3147 (insn, operands);
                  break;

                case 2:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3148 (insn, operands);
                  break;

                case 3:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3149 (insn, operands);
                  break;

                case 4:
                  if (
#line 18649 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3150 (insn, operands);
                  break;

                case 5:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3151 (insn, operands);
                  break;

                case 6:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3152 (insn, operands);
                  break;

                case 7:
                  if (
#line 18649 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3153 (insn, operands);
                  break;

                case 8:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3154 (insn, operands);
                  break;

                case 9:
                  if (
#line 18649 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3155 (insn, operands);
                  break;

                case 10:
                  if ((
#line 18649 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3156 (insn, operands);
                  break;

                case 11:
                  if (
#line 18649 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3157 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern186 ())
    {
    case 0:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1426 (insn, operands);
      break;

    case 1:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1427 (insn, operands);
      break;

    case 2:
      if ((
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1428 (insn, operands);
      break;

    case 3:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1429 (insn, operands);
      break;

    case 4:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1430 (insn, operands);
      break;

    case 5:
      if ((
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1431 (insn, operands);
      break;

    case 6:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1432 (insn, operands);
      break;

    case 7:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1433 (insn, operands);
      break;

    case 8:
      if ((
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1434 (insn, operands);
      break;

    case 9:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1435 (insn, operands);
      break;

    case 10:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1436 (insn, operands);
      break;

    case 11:
      if (((
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13737 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1437 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case AND:
      return split_68 (x1, insn);

    case IOR:
      return split_67 (x1, insn);

    case XOR:
      return split_66 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMUL_HIGHPART)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return NULL;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  x14 = XEXP (x12, 1);
  operands[5] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1430 (x1, 
E_SImode) != 0
          || !(
#line 10970 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_110 (insn, operands);

    case E_DImode:
      if (pattern1430 (x1, 
E_DImode) != 0
          || !(
#line 10970 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_111 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern300 (x4, 
E_CCmode, 
17) != 0)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return NULL;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!nonimmediate_operand (operands[2], E_HImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x7, 1);
  switch (GET_CODE (x9))
    {
    case ZERO_EXTEND:
      if (peep2_current_count < 4)
        return NULL;
      x10 = XEXP (x7, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_VOIDmode))
        return NULL;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || pattern1598 (x8) != 0)
        return NULL;
      x12 = XEXP (x8, 1);
      x13 = XEXP (x12, 0);
      x14 = XEXP (x13, 0);
      operands[4] = x14;
      if (!register_operand (operands[4], E_QImode))
        return NULL;
      x15 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x15) != SET)
        return NULL;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != IF_THEN_ELSE)
        return NULL;
      x17 = XEXP (x16, 0);
      if (!bt_comparison_operator (x17, E_VOIDmode))
        return NULL;
      operands[5] = x17;
      if (pattern1710 (x15) != 0)
        return NULL;
      x18 = XEXP (x16, 1);
      x19 = XEXP (x18, 0);
      operands[6] = x19;
      if (!
#line 22886 "../../../gcc/config/i386/i386.md"
(REGNO (operands[3]) == REGNO (operands[4])
   && peep2_reg_dead_p (3, operands[1])
   && peep2_reg_dead_p (3, operands[3])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_181 (insn, operands);

    case COMPARE:
      if (GET_MODE (x9) != E_CCZmode)
        return NULL;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return NULL;
      x20 = XEXP (x11, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x21 = XEXP (x9, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return NULL;
      x22 = XEXP (x11, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x12 = XEXP (x8, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!bt_comparison_operator (x13, E_VOIDmode))
        return NULL;
      operands[4] = x13;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 17
          || GET_MODE (x14) != E_CCZmode)
        return NULL;
      x23 = XEXP (x13, 1);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x24 = XEXP (x12, 1);
      if (GET_CODE (x24) != LABEL_REF)
        return NULL;
      x25 = XEXP (x12, 2);
      if (GET_CODE (x25) != PC)
        return NULL;
      x26 = XEXP (x8, 0);
      if (GET_CODE (x26) != PC)
        return NULL;
      x27 = XEXP (x24, 0);
      operands[5] = x27;
      if (!
#line 22919 "../../../gcc/config/i386/i386.md"
(REGNO (operands[1]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (2, operands[3])
   && peep2_regno_dead_p (3, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_182 (insn, operands);

    default:
      return NULL;
    }
}
